/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 307
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 307
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    case SUBREG:
    case TRUNCATE:
      operands[3] = x3;
      if (!subreg_lowpart_operator (operands[3], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 307
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern49 (x1); /* [-1, 1] */
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 2;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 3;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 4;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 5;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 6;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern69 (x3); /* [-1, 2] */
}

int
pattern73 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern79 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aligned_register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || pattern83 (x1, 
i1, 
i2, 
i3) != 0)
    return -1;
  return 0;
}

int
pattern86 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 15
      || pattern85 (x1, 
E_DImode, 
15) != 0)
    return -1;
  return 0;
}

int
pattern91 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern77 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern77 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern77 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern77 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern77 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_QImode:
      if (pattern90 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode) != 0)
        return -1;
      return 6;

    case E_HImode:
      if (pattern90 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 7;

    case E_SImode:
      if (pattern90 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 8;

    case E_DImode:
      if (pattern90 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern104 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          return pattern77 (x3, 
E_V8QImode); /* [-1, 0] */

        case E_V16QImode:
          if (pattern77 (x3, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_V4HImode:
          if (pattern77 (x3, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (pattern77 (x3, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V2SImode:
          if (pattern77 (x3, 
E_V2SImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern77 (x3, 
E_V4SImode) != 0)
            return -1;
          return 5;

        case E_V2DImode:
          if (pattern77 (x3, 
E_V2DImode) != 0)
            return -1;
          return 6;

        case E_QImode:
          if (pattern77 (x3, 
E_QImode) != 0)
            return -1;
          return 7;

        case E_HImode:
          if (pattern77 (x3, 
E_HImode) != 0)
            return -1;
          return 8;

        case E_SImode:
          if (pattern77 (x3, 
E_SImode) != 0)
            return -1;
          return 9;

        case E_DImode:
          if (pattern77 (x3, 
E_DImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case CONST_INT:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern100 (x3, 
E_V8QImode) != 0)
            return -1;
          return 11;

        case E_V16QImode:
          if (pattern100 (x3, 
E_V16QImode) != 0)
            return -1;
          return 12;

        case E_V4HImode:
          if (pattern101 (x3, 
E_V4HImode) != 0)
            return -1;
          return 13;

        case E_V8HImode:
          if (pattern101 (x3, 
E_V8HImode) != 0)
            return -1;
          return 14;

        case E_V2SImode:
          if (pattern102 (x3, 
E_V2SImode) != 0)
            return -1;
          return 15;

        case E_V4SImode:
          if (pattern102 (x3, 
E_V4SImode) != 0)
            return -1;
          return 16;

        case E_V2DImode:
          if (pattern103 (x3, 
E_V2DImode) != 0)
            return -1;
          return 17;

        case E_QImode:
          if (pattern100 (x3, 
E_QImode) != 0)
            return -1;
          return 18;

        case E_HImode:
          if (pattern101 (x3, 
E_HImode) != 0)
            return -1;
          return 19;

        case E_SImode:
          if (pattern102 (x3, 
E_SImode) != 0)
            return -1;
          return 20;

        case E_DImode:
          if (pattern103 (x3, 
E_DImode) != 0)
            return -1;
          return 21;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8SImode:
          if (!register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx8DImode:
          if (!register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V2SImode:
      if (!register_operand (operands[3], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[3], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern161 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 168)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern168 (x2, 
E_VNx8BFmode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern168 (x2, 
E_VNx8HFmode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern168 (x2, 
E_VNx4SFmode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern168 (x2, 
E_VNx2DFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern179 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  return pattern178 (
i1); /* [-1, 2] */
}

int
pattern185 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern184 (x3, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern184 (x3, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern184 (x3, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2BImode:
      if (pattern184 (x3, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern193 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern116 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern116 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern116 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          return pattern193 (x3, 
E_VNx16QImode, 
E_VNx4SImode); /* [-1, 0] */

        case E_VNx2DImode:
          if (pattern193 (x3, 
E_VNx8HImode, 
E_VNx2DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 168)
        return -1;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x6, 0, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern202 (x3, 
E_VNx16QImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern202 (x3, 
E_VNx8HImode, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern217 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern223 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 0;

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern236 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x4 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  if (!aarch64_reg_or_zero (operands[2], E_DImode))
    return -1;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern247 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || !aligned_register_operand (operands[3], E_VNx32QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || !aligned_register_operand (operands[3], E_VNx64QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || !aligned_register_operand (operands[3], E_VNx16HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || !aligned_register_operand (operands[3], E_VNx32HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return pattern246 (x1); /* [-1, 23] */

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[1] = x8;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      res = pattern250 (x1);
      if (res >= 0)
        return res + 24; /* [24, 47] */
      return -1;

    default:
      return -1;
    }
}

int
pattern256 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aligned_register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BFmode:
      if (!register_operand (operands[2], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!register_operand (operands[2], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!register_operand (operands[2], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!register_operand (operands[2], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern272 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  x8 = XVECEXP (x3, 0, 4);
  operands[5] = x8;
  x9 = XVECEXP (x3, 0, 5);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern271 (x3, 
E_VNx16QImode, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern271 (x3, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern271 (x3, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern271 (x3, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (pattern271 (x3, 
E_VNx8BFmode, 
E_VNx16BFmode) != 0)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (pattern271 (x3, 
E_VNx8HFmode, 
E_VNx16HFmode) != 0)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (pattern271 (x3, 
E_VNx4SFmode, 
E_VNx8SFmode) != 0)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (pattern271 (x3, 
E_VNx2DFmode, 
E_VNx4DFmode) != 0)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (pattern271 (x3, 
E_VNx16QImode, 
E_VNx64QImode) != 0)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (pattern271 (x3, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (pattern271 (x3, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (pattern271 (x3, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (pattern271 (x3, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (pattern271 (x3, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (pattern271 (x3, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (pattern271 (x3, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern289 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern288 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern288 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern291 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern290 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern290 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern295 (x1, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern295 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern295 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern301 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern301 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 1);
      operands[2] = x4;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              return pattern309 (x1, 
E_SImode); /* [-1, 2] */

            case E_DImode:
              res = pattern309 (x1, 
E_DImode);
              if (res >= 0)
                return res + 3; /* [3, 5] */
              return -1;

            default:
              return -1;
            }

        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern310 (x1, 
E_V8HImode, 
E_V8QImode) != 0)
                return -1;
              return 6;

            case E_V4SImode:
              if (pattern310 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
                return -1;
              return 7;

            case E_V2DImode:
              if (pattern310 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
                return -1;
              return 8;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern311 (x1, 
E_V8HImode, 
E_V16QImode, 
E_V8QImode) != 0)
            return -1;
          return 9;

        case E_V4SImode:
          if (pattern311 (x1, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern311 (x1, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (XINT (x1, 1))
    {
    case 169:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 307:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      res = pattern19 ();
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern340 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_VNx16BImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x5) != E_VNx16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sve_dup_operand (operands[1], E_QImode))
            return -1;
          return 0;

        case E_V16QImode:
          if (!nonimmediate_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx8QImode:
      if (!register_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x5) != E_VNx8QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 2;

    case E_VNx4QImode:
      if (!register_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x5) != E_VNx4QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 3;

    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x5) != E_VNx2QImode
          || !aarch64_sve_dup_operand (operands[1], E_QImode))
        return -1;
      return 4;

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x5) != E_VNx8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HImode:
          if (!aarch64_sve_dup_operand (operands[1], E_HImode))
            return -1;
          return 5;

        case E_V8HImode:
          if (!nonimmediate_operand (operands[1], E_V8HImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case E_VNx4HImode:
      if (!register_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x5) != E_VNx4HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode))
        return -1;
      return 7;

    case E_VNx2HImode:
      if (!register_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x5) != E_VNx2HImode
          || !aarch64_sve_dup_operand (operands[1], E_HImode))
        return -1;
      return 8;

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x5) != E_VNx4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!aarch64_sve_dup_operand (operands[1], E_SImode))
            return -1;
          return 9;

        case E_V4SImode:
          if (!nonimmediate_operand (operands[1], E_V4SImode))
            return -1;
          return 10;

        default:
          return -1;
        }

    case E_VNx2SImode:
      if (!register_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x5) != E_VNx2SImode
          || !aarch64_sve_dup_operand (operands[1], E_SImode))
        return -1;
      return 11;

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x5) != E_VNx2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!aarch64_sve_dup_operand (operands[1], E_DImode))
            return -1;
          return 12;

        case E_V2DImode:
          if (!nonimmediate_operand (operands[1], E_V2DImode))
            return -1;
          return 13;

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x5) != E_VNx8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_HFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_HFmode))
            return -1;
          return 14;

        case E_V8HFmode:
          if (!nonimmediate_operand (operands[1], E_V8HFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case E_VNx4HFmode:
      if (!register_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x5) != E_VNx4HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode))
        return -1;
      return 16;

    case E_VNx2HFmode:
      if (!register_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x5) != E_VNx2HFmode
          || !aarch64_sve_dup_operand (operands[1], E_HFmode))
        return -1;
      return 17;

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x5) != E_VNx8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_BFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_BFmode))
            return -1;
          return 18;

        case E_V8BFmode:
          if (!nonimmediate_operand (operands[1], E_V8BFmode))
            return -1;
          return 19;

        default:
          return -1;
        }

    case E_VNx4BFmode:
      if (!register_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x5) != E_VNx4BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode))
        return -1;
      return 20;

    case E_VNx2BFmode:
      if (!register_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x5) != E_VNx2BFmode
          || !aarch64_sve_dup_operand (operands[1], E_BFmode))
        return -1;
      return 21;

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x5) != E_VNx4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_SFmode))
            return -1;
          return 22;

        case E_V4SFmode:
          if (!nonimmediate_operand (operands[1], E_V4SFmode))
            return -1;
          return 23;

        default:
          return -1;
        }

    case E_VNx2SFmode:
      if (!register_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x5) != E_VNx2SFmode
          || !aarch64_sve_dup_operand (operands[1], E_SFmode))
        return -1;
      return 24;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x5) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DFmode:
          if (!aarch64_sve_dup_operand (operands[1], E_DFmode))
            return -1;
          return 25;

        case E_V2DFmode:
          if (!nonimmediate_operand (operands[1], E_V2DFmode))
            return -1;
          return 26;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern410 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern412 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_reg_or_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern420 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern424 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern430 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !aarch64_simd_reg_or_zero (operands[2], E_V8QImode)
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4HImode:
          if (!register_operand (operands[1], E_V4HImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HImode))
            return -1;
          return 1;

        case E_V4HFmode:
          if (!register_operand (operands[1], E_V4HFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V4HFmode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2SImode:
          if (!register_operand (operands[1], E_V2SImode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SImode))
            return -1;
          return 3;

        case E_V2SFmode:
          if (!register_operand (operands[1], E_V2SFmode)
              || !aarch64_simd_reg_or_zero (operands[2], E_V2SFmode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DFmode)
          || !aarch64_simd_reg_or_zero (operands[2], E_DFmode)
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !aarch64_logical_immediate (operands[3], E_SImode)
          || !register_operand (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !aarch64_logical_immediate (operands[3], E_DImode)
          || !register_operand (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern470 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != VEC_SELECT)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case SIGN_EXTEND:
      return pattern469 (x1, 
SIGN_EXTEND); /* [-1, 5] */

    case ZERO_EXTEND:
      res = pattern469 (x1, 
ZERO_EXTEND);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_vsm_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern480 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  operands[3] = x3;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x1, 0, 0);
      operands[1] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern476 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8QImode:
          if (pattern476 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4QImode:
          if (pattern476 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2QImode:
          if (pattern476 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern476 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern476 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2HImode:
          if (pattern476 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        case E_VNx4SImode:
          if (pattern476 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 7;

        case E_VNx2SImode:
          if (pattern476 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 8;

        case E_VNx2DImode:
          if (pattern476 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 9;

        case E_V2DImode:
          if (pattern476 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 10;

        default:
          return -1;
        }

    case UNSPEC:
      res = pattern479 (x1, 
SMAX);
      if (res >= 0)
        return res + 11; /* [11, 14] */
      return -1;

    default:
      return -1;
    }
}

int
pattern496 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern502 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SImode:
          return pattern500 (x1, 
E_V2SImode, 
E_V8QImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern500 (x1, 
E_V4SImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (!register_operand (operands[0], E_VNx4SImode)
              || GET_MODE (x1) != E_VNx4SImode
              || GET_MODE (x2) != E_VNx4SImode
              || !register_operand (operands[3], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[1], E_VNx16QImode)
                  || !register_operand (operands[2], E_VNx16QImode))
                return -1;
              return 2;

            case E_VNx8HImode:
              if (!register_operand (operands[1], E_VNx8HImode)
                  || !register_operand (operands[2], E_VNx8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_VNx2DImode:
          if (pattern500 (x1, 
E_VNx2DImode, 
E_VNx8HImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 168)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      x7 = XVECEXP (x4, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x1, 1);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          res = pattern501 (x1, 
E_VNx4SImode);
          if (res >= 0)
            return res + 5; /* [5, 6] */
          return -1;

        case E_VNx2DImode:
          res = pattern501 (x1, 
E_VNx2DImode);
          if (res >= 0)
            return res + 7; /* [7, 8] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern531 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[3] = x4;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XEXP (x3, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XEXP (x3, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern530 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern530 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern530 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern539 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern538 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern538 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern538 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern549 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XEXP (x4, 1);
  operands[2] = x6;
  return pattern540 (x1); /* [-1, 2] */
}

int
pattern554 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  x5 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[3] = x5;
      x6 = XEXP (x1, 1);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern553 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern553 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XVECEXP (x7, 0, 0);
      operands[4] = x9;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !register_operand (operands[2], E_V4HImode)
              || GET_MODE (x5) != E_HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !register_operand (operands[2], E_V2SImode)
              || GET_MODE (x5) != E_SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern590 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_select_half (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_select_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern598 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern602 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      switch (XINT (x3, 1))
        {
        case 115:
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              return pattern592 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 5] */

            case E_VNx4HImode:
              res = pattern592 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 6; /* [6, 11] */
              return -1;

            case E_VNx2HImode:
              res = pattern592 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 12; /* [12, 17] */
              return -1;

            case E_VNx4SImode:
              res = pattern592 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 18; /* [18, 23] */
              return -1;

            case E_VNx2SImode:
              res = pattern592 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 24; /* [24, 29] */
              return -1;

            case E_VNx2DImode:
              res = pattern592 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 30; /* [30, 35] */
              return -1;

            default:
              return -1;
            }

        case 403:
          x7 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              res = pattern593 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
              if (res >= 0)
                return res + 36; /* [36, 41] */
              return -1;

            case E_VNx4HImode:
              res = pattern593 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 42; /* [42, 47] */
              return -1;

            case E_VNx2HImode:
              res = pattern593 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 48; /* [48, 53] */
              return -1;

            case E_VNx4SImode:
              res = pattern593 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 54; /* [54, 59] */
              return -1;

            case E_VNx2SImode:
              res = pattern593 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 60; /* [60, 65] */
              return -1;

            case E_VNx2DImode:
              res = pattern593 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 66; /* [66, 71] */
              return -1;

            default:
              return -1;
            }

        case 404:
          x7 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              res = pattern594 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
              if (res >= 0)
                return res + 72; /* [72, 77] */
              return -1;

            case E_VNx4HImode:
              res = pattern594 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 78; /* [78, 83] */
              return -1;

            case E_VNx2HImode:
              res = pattern594 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 84; /* [84, 89] */
              return -1;

            case E_VNx4SImode:
              res = pattern594 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 90; /* [90, 95] */
              return -1;

            case E_VNx2SImode:
              res = pattern594 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 96; /* [96, 101] */
              return -1;

            case E_VNx2DImode:
              res = pattern594 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 102; /* [102, 107] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 125)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          res = pattern595 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
          if (res >= 0)
            return res + 108; /* [108, 113] */
          return -1;

        case E_VNx4HImode:
          res = pattern595 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 114; /* [114, 119] */
          return -1;

        case E_VNx2HImode:
          res = pattern595 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 120; /* [120, 125] */
          return -1;

        case E_VNx4SImode:
          res = pattern595 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 126; /* [126, 131] */
          return -1;

        case E_VNx2SImode:
          res = pattern595 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 132; /* [132, 137] */
          return -1;

        case E_VNx2DImode:
          res = pattern595 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 138; /* [138, 143] */
          return -1;

        default:
          return -1;
        }

    case 7:
      x5 = XVECEXP (x3, 0, 0);
      operands[5] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      x8 = XVECEXP (x3, 0, 3);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      operands[4] = x9;
      switch (XINT (x3, 1))
        {
        case 120:
          x10 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SCRATCH)
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              x12 = XVECEXP (x3, 0, 5);
              operands[7] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4HImode:
                  res = pattern596 (x1, 
E_VNx4HImode);
                  if (res >= 0)
                    return res + 144; /* [144, 145] */
                  return -1;

                case E_VNx4SImode:
                  res = pattern596 (x1, 
E_VNx4SImode);
                  if (res >= 0)
                    return res + 146; /* [146, 147] */
                  return -1;

                case E_VNx2HImode:
                  res = pattern597 (x1, 
E_VNx2HImode);
                  if (res >= 0)
                    return res + 148; /* [148, 150] */
                  return -1;

                case E_VNx2SImode:
                  res = pattern597 (x1, 
E_VNx2SImode);
                  if (res >= 0)
                    return res + 151; /* [151, 153] */
                  return -1;

                case E_VNx2DImode:
                  res = pattern597 (x1, 
E_VNx2DImode);
                  if (res >= 0)
                    return res + 154; /* [154, 156] */
                  return -1;

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 125
                  || GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x13 = XVECEXP (x7, 0, 0);
              operands[7] = x13;
              x14 = XVECEXP (x7, 0, 1);
              if (GET_MODE (x14) != E_VNx2DImode)
                return -1;
              x12 = XVECEXP (x3, 0, 5);
              operands[8] = x12;
              switch (GET_CODE (x14))
                {
                case SIGN_EXTEND:
                  x15 = XEXP (x14, 0);
                  switch (GET_CODE (x15))
                    {
                    case REG:
                    case SUBREG:
                      res = pattern599 (x1);
                      if (res >= 0)
                        return res + 157; /* [157, 165] */
                      return -1;

                    case TRUNCATE:
                      if (GET_MODE (x15) != E_VNx2SImode)
                        return -1;
                      x16 = XEXP (x15, 0);
                      operands[2] = x16;
                      if (!register_operand (operands[2], E_VNx2DImode))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx2HImode:
                          res = pattern598 (x1, 
E_VNx2HImode);
                          if (res >= 0)
                            return res + 166; /* [166, 168] */
                          return -1;

                        case E_VNx2SImode:
                          res = pattern598 (x1, 
E_VNx2SImode);
                          if (res >= 0)
                            return res + 169; /* [169, 171] */
                          return -1;

                        case E_VNx2DImode:
                          res = pattern598 (x1, 
E_VNx2DImode);
                          if (res >= 0)
                            return res + 172; /* [172, 174] */
                          return -1;

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  res = pattern599 (x1);
                  if (res >= 0)
                    return res + 175; /* [175, 183] */
                  return -1;

                default:
                  return -1;
                }

            case AND:
              if (GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[7] = x4;
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x7, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x18 = XEXP (x7, 1);
              operands[6] = x18;
              if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
                return -1;
              x12 = XVECEXP (x3, 0, 5);
              operands[8] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx2HImode:
                  res = pattern598 (x1, 
E_VNx2HImode);
                  if (res >= 0)
                    return res + 184; /* [184, 186] */
                  return -1;

                case E_VNx2SImode:
                  res = pattern598 (x1, 
E_VNx2SImode);
                  if (res >= 0)
                    return res + 187; /* [187, 189] */
                  return -1;

                case E_VNx2DImode:
                  res = pattern598 (x1, 
E_VNx2DImode);
                  if (res >= 0)
                    return res + 190; /* [190, 192] */
                  return -1;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          x12 = XVECEXP (x3, 0, 5);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x19 = XEXP (x12, 0);
          if (GET_CODE (x19) != SCRATCH)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 86
              || GET_MODE (x10) != E_VNx16BImode)
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4SImode:
                  if (!register_operand (operands[0], E_VNx4SImode)
                      || GET_MODE (x1) != E_VNx4SImode
                      || !general_operand (operands[6], E_VNx4BImode)
                      || GET_MODE (x2) != E_VNx4SImode
                      || !register_operand (operands[5], E_VNx4BImode)
                      || !register_operand (operands[2], E_VNx4SImode))
                    return -1;
                  switch (GET_MODE (x3))
                    {
                    case E_VNx4QImode:
                      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_b (operands[4], E_DImode))
                        return -1;
                      return 193;

                    case E_VNx4HImode:
                      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_h (operands[4], E_DImode))
                        return -1;
                      return 194;

                    default:
                      return -1;
                    }

                case E_VNx2DImode:
                  if (!register_operand (operands[0], E_VNx2DImode)
                      || GET_MODE (x1) != E_VNx2DImode
                      || !general_operand (operands[6], E_VNx2BImode)
                      || GET_MODE (x2) != E_VNx2DImode
                      || !register_operand (operands[5], E_VNx2BImode)
                      || !register_operand (operands[2], E_VNx2DImode))
                    return -1;
                  switch (GET_MODE (x3))
                    {
                    case E_VNx2QImode:
                      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_b (operands[4], E_DImode))
                        return -1;
                      return 195;

                    case E_VNx2HImode:
                      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_h (operands[4], E_DImode))
                        return -1;
                      return 196;

                    case E_VNx2SImode:
                      if (!aarch64_sve_gather_offset_w (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_w (operands[4], E_DImode))
                        return -1;
                      return 197;

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 125
                  || GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x14 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x14) != SIGN_EXTEND
                  || GET_MODE (x14) != E_VNx2DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != TRUNCATE
                  || GET_MODE (x15) != E_VNx2SImode
                  || !register_operand (operands[0], E_VNx2DImode)
                  || GET_MODE (x1) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              if (GET_MODE (x2) != E_VNx2DImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x13 = XVECEXP (x7, 0, 0);
              operands[7] = x13;
              x16 = XEXP (x15, 0);
              operands[2] = x16;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              res = pattern600 (x3);
              if (res >= 0)
                return res + 198; /* [198, 200] */
              return -1;

            case AND:
              if (GET_MODE (x7) != E_VNx2DImode
                  || !register_operand (operands[0], E_VNx2DImode)
                  || GET_MODE (x1) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[7] = x4;
              if (GET_MODE (x2) != E_VNx2DImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x7, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x18 = XEXP (x7, 1);
              operands[6] = x18;
              if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
                return -1;
              res = pattern600 (x3);
              if (res >= 0)
                return res + 201; /* [201, 203] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (XINT (x3, 1) != 122)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x20 = XEXP (x8, 0);
      if (GET_CODE (x20) != SCRATCH)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          res = pattern601 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 204; /* [204, 209] */
          return -1;

        case E_VNx2DImode:
          res = pattern601 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 210; /* [210, 215] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern801 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern808 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x2, 1);
      operands[3] = x5;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x4, 1);
      operands[4] = x7;
      if (!const_int_operand (operands[4], E_VOIDmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern824 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern830 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_V2SImode
      || !register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode)
      || GET_MODE (x2) != E_V2SImode)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V8QImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V8QImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V2SImode))
    return -1;
  return 0;
}

int
pattern840 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !memory_operand (operands[1], i1)
      || !memory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern846 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[5] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != AND
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!const_int_operand (operands[4], E_VOIDmode))
    return -1;
  return pattern2 (x1); /* [-1, 1] */
}

int
pattern854 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i2)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern859 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern866 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx8QImode:
      return 0;

    case E_VNx4QImode:
      return 1;

    case E_VNx2QImode:
      return 2;

    case E_VNx4HImode:
      return 3;

    case E_VNx2HImode:
      return 4;

    case E_VNx2SImode:
      return 5;

    default:
      return -1;
    }
}

int
pattern878 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_VNx2DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern876 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern876 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern876 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern877 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern877 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SImode:
          if (pattern877 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern893 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern897 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern904 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[4] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern903 (x1, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4HImode:
      if (pattern903 (x1, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern903 (x1, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern911 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern918 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_nonimmediate_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern922 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_MODE (x4))
    {
    case E_SImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      return pattern921 (x7, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      if (pattern921 (x7, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern935 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V8QImode:
      if (!register_operand (operands[2], E_V8QImode)
          || !memory_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V4HImode:
      if (!register_operand (operands[2], E_V4HImode)
          || !memory_operand (operands[3], E_V4HImode))
        return -1;
      return 1;

    case E_V4HFmode:
      if (!register_operand (operands[2], E_V4HFmode)
          || !memory_operand (operands[3], E_V4HFmode))
        return -1;
      return 2;

    case E_V2SImode:
      if (!register_operand (operands[2], E_V2SImode)
          || !memory_operand (operands[3], E_V2SImode))
        return -1;
      return 3;

    case E_V2SFmode:
      if (!register_operand (operands[2], E_V2SFmode)
          || !memory_operand (operands[3], E_V2SFmode))
        return -1;
      return 4;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !memory_operand (operands[3], E_DFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern944 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_sve_ldff1_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern948 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i3)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern953 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern961 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern964 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[3], i1))
    return -1;
  return 0;
}

int
pattern972 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern976 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SIGN_EXTEND)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case VEC_SELECT:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != PARALLEL
          || XVECLEN (x3, 0) != 1)
        return -1;
      return 0;

    case REG:
    case SUBREG:
      operands[3] = x2;
      return 1;

    default:
      return -1;
    }
}

int
pattern982 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1)
      || !scratch_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern987 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern870 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern870 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern870 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 4
          || XINT (x3, 1) != 393)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern995 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern998 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1005 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1012 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HFmode
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V4HFmode:
      if (!register_operand (operands[2], E_V4HFmode))
        return -1;
      return 0;

    case E_V8HFmode:
      if (!register_operand (operands[2], E_V8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1019 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1027 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[2]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 0;

        case E_V8HImode:
          return 1;

        case E_V4SImode:
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
      if (!aarch64_simd_shift_imm_offset_di (operands[2], E_DImode)
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !aarch64_simd_or_scalar_imm_zero (operands[4], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_TImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_TImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_TImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_int_rnd_operand (operands[3], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1042 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1048 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1044 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1044 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1044 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1044 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1047 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1047 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1047 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1066 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1072 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1082 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern1081 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern1081 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern1081 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1094 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  operands[1] = x4;
  if (!aarch64_sve_ptrue_svpattern_immediate (operands[1], E_VNx16BImode))
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 128
      || GET_MODE (x5) != E_VNx16BImode)
    return -1;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[3] = x7;
  x8 = XVECEXP (x5, 0, 0);
  operands[4] = x8;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x9 = XVECEXP (x5, 0, 1);
  operands[5] = x9;
  if (!aarch64_simd_imm_zero (operands[5], E_VNx16BImode))
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x10))
    {
    case SET:
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x12 = XEXP (x10, 1);
      if (!rtx_equal_p (x12, operands[1]))
        return -1;
      return 0;

    case CLOBBER:
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1107 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_sve_float_arith_immediate (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          return pattern1109 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SFmode:
          if (pattern1109 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DFmode:
          if (pattern1109 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        case E_VNx8BFmode:
          if (pattern1109 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x1, 0, 2);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern1110 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (pattern1110 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SFmode:
          if (pattern1110 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DFmode:
          if (pattern1110 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1133 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_VNx2DImode
      || !register_operand (operands[5], E_VNx2BImode)
      || !register_operand (operands[1], E_DImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  x3 = XEXP (x1, 1);
  operands[6] = x3;
  if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
    return -1;
  return 0;
}

int
pattern1140 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1148 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1156 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  x10 = XVECEXP (x1, 0, 1);
  x11 = XEXP (x10, 1);
  switch (GET_CODE (x11))
    {
    case AND:
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != NOT)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != i1)
        return -1;
      x14 = XEXP (x13, 0);
      if (!rtx_equal_p (x14, operands[1]))
        return -1;
      x15 = XEXP (x13, 1);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x11, 1);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || GET_MODE (x6) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !register_operand (operands[3], E_SImode)
              || pattern1155 (x11, 
E_SImode) != 0)
            return -1;
          return 0;

        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !register_operand (operands[3], E_DImode)
              || pattern1155 (x11, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_DImode)
        return -1;
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != AND
          || GET_MODE (x12) != E_SImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != NOT
          || GET_MODE (x13) != E_SImode)
        return -1;
      x14 = XEXP (x13, 0);
      if (GET_CODE (x14) != i1
          || GET_MODE (x14) != E_SImode
          || GET_MODE (x4) != E_SImode
          || GET_MODE (x5) != E_SImode
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode)
          || !register_operand (operands[0], E_DImode))
        return -1;
      x17 = XEXP (x14, 0);
      if (!rtx_equal_p (x17, operands[1]))
        return -1;
      x18 = XEXP (x14, 1);
      if (!rtx_equal_p (x18, operands[2]))
        return -1;
      x19 = XEXP (x12, 1);
      if (!rtx_equal_p (x19, operands[3]))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1194 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1201 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1205 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[3] = x5;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  return 0;
}

int
pattern1215 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[4], i4))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i3)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1224 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern1233 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1239 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1246 (rtx x1, unsigned int i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern1252 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1256 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_SFmode:
      if (!register_operand (operands[2], E_SFmode)
          || !register_operand (operands[3], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[2], E_DFmode)
          || !register_operand (operands[3], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1270 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XEXP (x3, 0);
  switch (GET_MODE (x12))
    {
    case E_DImode:
      return 0;

    case E_TImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern1280 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1290 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1299 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !vect_par_cnst_hi_half (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1310 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode
          || !aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[7], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (pattern1307 (x1, 
E_VNx2HImode) != 0)
        return -1;
      return 1;

    case E_VNx2HFmode:
      if (pattern1307 (x1, 
E_VNx2HFmode) != 0)
        return -1;
      return 2;

    case E_VNx2BFmode:
      if (pattern1307 (x1, 
E_VNx2BFmode) != 0)
        return -1;
      return 3;

    case E_VNx2SImode:
      if (pattern1308 (x1, 
E_VNx2SImode) != 0)
        return -1;
      return 4;

    case E_VNx2SFmode:
      if (pattern1308 (x1, 
E_VNx2SFmode) != 0)
        return -1;
      return 5;

    case E_VNx2DImode:
      if (pattern1309 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern1309 (x1, 
E_VNx2DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern1324 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1334 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8QImode:
      if (!register_operand (operands[2], E_VNx8QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1339 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || pattern1338 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1344 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16BFmode:
      if (!aligned_register_operand (operands[1], E_VNx16BFmode)
          || GET_MODE (x1) != E_VNx16BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx32BFmode:
      if (!aligned_register_operand (operands[1], E_VNx32BFmode)
          || GET_MODE (x1) != E_VNx32BFmode
          || !register_operand (operands[2], E_VNx8BFmode))
        return -1;
      return 1;

    case E_VNx16HFmode:
      if (!aligned_register_operand (operands[1], E_VNx16HFmode)
          || GET_MODE (x1) != E_VNx16HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 2;

    case E_VNx32HFmode:
      if (!aligned_register_operand (operands[1], E_VNx32HFmode)
          || GET_MODE (x1) != E_VNx32HFmode
          || !register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1356 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_operator (operands[7], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[10] = x4;
  x5 = XEXP (x4, 1);
  operands[5] = x5;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !aarch64_stp_reg_operand (operands[3], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  if (!rtx_equal_p (x9, operands[0]))
    return -1;
  x10 = XEXP (x8, 1);
  if (!rtx_equal_p (x10, operands[4]))
    return -1;
  return 0;
}

int
pattern1366 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16HImode:
      if (!aligned_register_operand (operands[2], E_VNx16HImode)
          || GET_MODE (x1) != E_VNx16HImode)
        return -1;
      return 0;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[2], E_VNx32HImode)
          || GET_MODE (x1) != E_VNx32HImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x3, 0);
  if (!cc_register (x5, E_VOIDmode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case COMPARE:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 1
          || XINT (x7, 1) != 113)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      x10 = XEXP (x6, 1);
      operands[3] = x10;
      x11 = XVECEXP (x7, 0, 0);
      operands[5] = x11;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 7; /* ccmpccsi */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 8; /* ccmpccdi */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1261 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 765 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 9; /* ccmpccfpsf */
              break;

            case 1:
              if (
#line 765 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 10; /* ccmpccfpdf */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1261 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 765 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 11; /* ccmpccfpesf */

        case 1:
          if (!
#line 765 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 12; /* ccmpccfpedf */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x6, 0) != 1
          || XINT (x6, 1) != 113)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != COMPARE)
        return -1;
      x8 = XEXP (x1, 0);
      operands[1] = x8;
      operands[4] = x3;
      operands[0] = x5;
      x12 = XVECEXP (x6, 0, 0);
      operands[5] = x12;
      if (!immediate_operand (operands[5], E_VOIDmode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[2] = x13;
      x14 = XEXP (x7, 1);
      operands[3] = x14;
      if (cc_register (operands[1], E_CCmode)
          && GET_MODE (x2) == E_CCmode
          && GET_MODE (x6) == E_CCmode
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[2]))
            {
            case E_SImode:
              if (register_operand (operands[2], E_SImode)
                  && aarch64_ccmp_operand (operands[3], E_SImode))
                return 13; /* ccmpccsi_rev */
              break;

            case E_DImode:
              if (register_operand (operands[2], E_DImode)
                  && aarch64_ccmp_operand (operands[3], E_DImode))
                return 14; /* ccmpccdi_rev */
              break;

            default:
              break;
            }
        }
      if (cc_register (operands[1], E_CCFPmode))
        {
          switch (pattern1262 (x2, 
E_CCFPmode))
            {
            case 0:
              if (
#line 802 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 15; /* ccmpccfpsf_rev */
              break;

            case 1:
              if (
#line 802 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return 16; /* ccmpccfpdf_rev */
              break;

            default:
              break;
            }
        }
      if (!cc_register (operands[1], E_CCFPEmode))
        return -1;
      switch (pattern1262 (x2, 
E_CCFPEmode))
        {
        case 0:
          if (!
#line 802 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 17; /* ccmpccfpesf_rev */

        case 1:
          if (!
#line 802 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 18; /* ccmpccfpedf_rev */

        default:
          return -1;
        }

    case LABEL_REF:
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x1, 0);
      if (GET_CODE (x8) != PC)
        return -1;
      operands[0] = x3;
      operands[1] = x5;
      x9 = XEXP (x6, 0);
      operands[2] = x9;
      return 19; /* condjump */

    case CONST_INT:
    case REG:
    case SUBREG:
      operands[3] = x6;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      operands[1] = x3;
      operands[2] = x5;
      x7 = XEXP (x2, 2);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern1056 (x2, 
E_QImode) != 0
              || !
#line 4551 "../../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 455; /* *cmovqi_insn */

        case E_HImode:
          if (pattern1056 (x2, 
E_HImode) != 0
              || !
#line 4551 "../../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 456; /* *cmovhi_insn */

        case E_SImode:
          if (pattern1056 (x2, 
E_SImode) != 0
              || !
#line 4551 "../../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 457; /* *cmovsi_insn */

        case E_DImode:
          if (pattern1056 (x2, 
E_DImode) != 0
              || !
#line 4551 "../../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
            return -1;
          return 458; /* *cmovdi_insn */

        case E_SFmode:
          if (pattern1057 (x2, 
E_SFmode) != 0
              || !
#line 4628 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 463; /* *cmovsf_insn */

        case E_DFmode:
          if (pattern1057 (x2, 
E_DFmode) != 0
              || !
#line 4628 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 464; /* *cmovdf_insn */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x2, 2);
      if (GET_CODE (x7) != ZERO_EXTEND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x1, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      operands[1] = x3;
      operands[2] = x5;
      x9 = XEXP (x6, 0);
      operands[3] = x9;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x7, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      return 462; /* *cmovdi_insn_uxtw */

    default:
      return -1;
    }
}

 int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4465; /* aarch64_simd_ld3rv8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4466; /* aarch64_simd_ld3rv4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4467; /* aarch64_simd_ld3rv2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4468; /* aarch64_simd_ld3rdi */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4469; /* aarch64_simd_ld3rv4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4470; /* aarch64_simd_ld3rv2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4471; /* aarch64_simd_ld3rdf */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4472; /* aarch64_simd_ld3rv4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4473; /* aarch64_simd_ld3rv16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4474; /* aarch64_simd_ld3rv8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4475; /* aarch64_simd_ld3rv4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4476; /* aarch64_simd_ld3rv2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4477; /* aarch64_simd_ld3rv8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4478; /* aarch64_simd_ld3rv4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4479; /* aarch64_simd_ld3rv2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !
#line 7672 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4480; /* aarch64_simd_ld3rv8bf */

    default:
      return -1;
    }
}

 int
recog_24 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode)
          || GET_MODE (x3) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4803; /* aarch64_ld2v8qi_dreg */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode)
          || GET_MODE (x3) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4804; /* aarch64_ld2v4hi_dreg */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode)
          || GET_MODE (x3) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4805; /* aarch64_ld2v2si_dreg */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode)
          || GET_MODE (x3) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4806; /* aarch64_ld2v4hf_dreg */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode)
          || GET_MODE (x3) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4807; /* aarch64_ld2v2sf_dreg */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode)
          || GET_MODE (x3) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8383 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4808; /* aarch64_ld2v4bf_dreg */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode)
          || GET_MODE (x3) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8393 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4809; /* aarch64_ld2di_dreg */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode)
          || GET_MODE (x3) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8393 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4810; /* aarch64_ld2df_dreg */

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[1], E_VNx16BImode)
          || !
#line 154 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11146; /* aarch64_pmov_to_vnx16qi */

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8BImode)
          || !
#line 154 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11147; /* aarch64_pmov_to_vnx8hi */

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !
#line 154 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11148; /* aarch64_pmov_to_vnx4si */

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2BImode)
          || !
#line 154 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11149; /* aarch64_pmov_to_vnx2di */

    default:
      return -1;
    }
}

 int
recog_33 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern61 (x1))
    {
    case 0:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5022; /* aarch64_rev64v8qi */

    case 1:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5031; /* aarch64_rev64v16qi */

    case 2:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5034; /* aarch64_rev64v4hi */

    case 3:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5043; /* aarch64_rev64v8hi */

    case 4:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5046; /* aarch64_rev64v2si */

    case 5:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5055; /* aarch64_rev64v4si */

    case 6:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5058; /* aarch64_rev64v2di */

    case 7:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5061; /* aarch64_rev64v4hf */

    case 8:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5070; /* aarch64_rev64v8hf */

    case 9:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5073; /* aarch64_rev64v4bf */

    case 10:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5082; /* aarch64_rev64v8bf */

    case 11:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5085; /* aarch64_rev64v2sf */

    case 12:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5094; /* aarch64_rev64v4sf */

    case 13:
      if (!
#line 8677 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5097; /* aarch64_rev64v2df */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern72 (x1))
    {
    case 0:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12907; /* aarch64_sve_uzpvnx64qi */

    case 1:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12909; /* aarch64_sve_uzpvnx32hi */

    case 2:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12911; /* aarch64_sve_uzpvnx16si */

    case 3:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12913; /* aarch64_sve_uzpvnx8di */

    case 4:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12915; /* aarch64_sve_uzpvnx32bf */

    case 5:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12917; /* aarch64_sve_uzpvnx32hf */

    case 6:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12919; /* aarch64_sve_uzpvnx16sf */

    case 7:
      if (!
#line 3894 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12921; /* aarch64_sve_uzpvnx8df */

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern54 (x1))
    {
    case 0:
      if (!(
#line 6843 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 901; /* rinthf2 */

    case 1:
      if (!
#line 6843 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 908; /* rintsf2 */

    case 2:
      if (!
#line 6843 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 915; /* rintdf2 */

    case 3:
      if (!(
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2502; /* rintv4hf2 */

    case 4:
      if (!(
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2513; /* rintv8hf2 */

    case 5:
      if (!
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2530; /* rintv2sf2 */

    case 6:
      if (!
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2541; /* rintv4sf2 */

    case 7:
      if (!
#line 3005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2548; /* rintv2df2 */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern602 (x2))
    {
    case 0:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5781; /* aarch64_load_extendvnx8hivnx8qi */

    case 1:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5783; /* aarch64_load_extendvnx8hivnx4qi */

    case 2:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5785; /* aarch64_load_extendvnx8hivnx2qi */

    case 3:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5787; /* aarch64_load_extendvnx8hivnx4hi */

    case 4:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5789; /* aarch64_load_extendvnx8hivnx2hi */

    case 5:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5791; /* aarch64_load_extendvnx8hivnx2si */

    case 6:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5793; /* aarch64_load_extendvnx4hivnx8qi */

    case 7:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5795; /* aarch64_load_extendvnx4hivnx4qi */

    case 8:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5797; /* aarch64_load_extendvnx4hivnx2qi */

    case 9:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5799; /* aarch64_load_extendvnx4hivnx4hi */

    case 10:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5801; /* aarch64_load_extendvnx4hivnx2hi */

    case 11:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5803; /* aarch64_load_extendvnx4hivnx2si */

    case 12:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5805; /* aarch64_load_extendvnx2hivnx8qi */

    case 13:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5807; /* aarch64_load_extendvnx2hivnx4qi */

    case 14:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5809; /* aarch64_load_extendvnx2hivnx2qi */

    case 15:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5811; /* aarch64_load_extendvnx2hivnx4hi */

    case 16:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5813; /* aarch64_load_extendvnx2hivnx2hi */

    case 17:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5815; /* aarch64_load_extendvnx2hivnx2si */

    case 18:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5817; /* aarch64_load_extendvnx4sivnx8qi */

    case 19:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5819; /* aarch64_load_extendvnx4sivnx4qi */

    case 20:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5821; /* aarch64_load_extendvnx4sivnx2qi */

    case 21:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5823; /* aarch64_load_extendvnx4sivnx4hi */

    case 22:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5825; /* aarch64_load_extendvnx4sivnx2hi */

    case 23:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5827; /* aarch64_load_extendvnx4sivnx2si */

    case 24:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5829; /* aarch64_load_extendvnx2sivnx8qi */

    case 25:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5831; /* aarch64_load_extendvnx2sivnx4qi */

    case 26:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5833; /* aarch64_load_extendvnx2sivnx2qi */

    case 27:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5835; /* aarch64_load_extendvnx2sivnx4hi */

    case 28:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5837; /* aarch64_load_extendvnx2sivnx2hi */

    case 29:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5839; /* aarch64_load_extendvnx2sivnx2si */

    case 30:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5841; /* aarch64_load_extendvnx2divnx8qi */

    case 31:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5843; /* aarch64_load_extendvnx2divnx4qi */

    case 32:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5845; /* aarch64_load_extendvnx2divnx2qi */

    case 33:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5847; /* aarch64_load_extendvnx2divnx4hi */

    case 34:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5849; /* aarch64_load_extendvnx2divnx2hi */

    case 35:
      if (!
#line 1351 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5851; /* aarch64_load_extendvnx2divnx2si */

    case 36:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5941; /* aarch64_ldff1_extendvnx8hivnx8qi */

    case 37:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5945; /* aarch64_ldff1_extendvnx8hivnx4qi */

    case 38:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5949; /* aarch64_ldff1_extendvnx8hivnx2qi */

    case 39:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5953; /* aarch64_ldff1_extendvnx8hivnx4hi */

    case 40:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5957; /* aarch64_ldff1_extendvnx8hivnx2hi */

    case 41:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5961; /* aarch64_ldff1_extendvnx8hivnx2si */

    case 42:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5965; /* aarch64_ldff1_extendvnx4hivnx8qi */

    case 43:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5969; /* aarch64_ldff1_extendvnx4hivnx4qi */

    case 44:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5973; /* aarch64_ldff1_extendvnx4hivnx2qi */

    case 45:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5977; /* aarch64_ldff1_extendvnx4hivnx4hi */

    case 46:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5981; /* aarch64_ldff1_extendvnx4hivnx2hi */

    case 47:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5985; /* aarch64_ldff1_extendvnx4hivnx2si */

    case 48:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5989; /* aarch64_ldff1_extendvnx2hivnx8qi */

    case 49:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5993; /* aarch64_ldff1_extendvnx2hivnx4qi */

    case 50:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5997; /* aarch64_ldff1_extendvnx2hivnx2qi */

    case 51:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6001; /* aarch64_ldff1_extendvnx2hivnx4hi */

    case 52:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6005; /* aarch64_ldff1_extendvnx2hivnx2hi */

    case 53:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6009; /* aarch64_ldff1_extendvnx2hivnx2si */

    case 54:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6013; /* aarch64_ldff1_extendvnx4sivnx8qi */

    case 55:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6017; /* aarch64_ldff1_extendvnx4sivnx4qi */

    case 56:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6021; /* aarch64_ldff1_extendvnx4sivnx2qi */

    case 57:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6025; /* aarch64_ldff1_extendvnx4sivnx4hi */

    case 58:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6029; /* aarch64_ldff1_extendvnx4sivnx2hi */

    case 59:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6033; /* aarch64_ldff1_extendvnx4sivnx2si */

    case 60:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6037; /* aarch64_ldff1_extendvnx2sivnx8qi */

    case 61:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6041; /* aarch64_ldff1_extendvnx2sivnx4qi */

    case 62:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6045; /* aarch64_ldff1_extendvnx2sivnx2qi */

    case 63:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6049; /* aarch64_ldff1_extendvnx2sivnx4hi */

    case 64:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6053; /* aarch64_ldff1_extendvnx2sivnx2hi */

    case 65:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6057; /* aarch64_ldff1_extendvnx2sivnx2si */

    case 66:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6061; /* aarch64_ldff1_extendvnx2divnx8qi */

    case 67:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6065; /* aarch64_ldff1_extendvnx2divnx4qi */

    case 68:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6069; /* aarch64_ldff1_extendvnx2divnx2qi */

    case 69:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6073; /* aarch64_ldff1_extendvnx2divnx4hi */

    case 70:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6077; /* aarch64_ldff1_extendvnx2divnx2hi */

    case 71:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6081; /* aarch64_ldff1_extendvnx2divnx2si */

    case 72:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5942; /* aarch64_ldnf1_extendvnx8hivnx8qi */

    case 73:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5946; /* aarch64_ldnf1_extendvnx8hivnx4qi */

    case 74:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5950; /* aarch64_ldnf1_extendvnx8hivnx2qi */

    case 75:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5954; /* aarch64_ldnf1_extendvnx8hivnx4hi */

    case 76:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5958; /* aarch64_ldnf1_extendvnx8hivnx2hi */

    case 77:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5962; /* aarch64_ldnf1_extendvnx8hivnx2si */

    case 78:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5966; /* aarch64_ldnf1_extendvnx4hivnx8qi */

    case 79:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5970; /* aarch64_ldnf1_extendvnx4hivnx4qi */

    case 80:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5974; /* aarch64_ldnf1_extendvnx4hivnx2qi */

    case 81:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5978; /* aarch64_ldnf1_extendvnx4hivnx4hi */

    case 82:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5982; /* aarch64_ldnf1_extendvnx4hivnx2hi */

    case 83:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5986; /* aarch64_ldnf1_extendvnx4hivnx2si */

    case 84:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5990; /* aarch64_ldnf1_extendvnx2hivnx8qi */

    case 85:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5994; /* aarch64_ldnf1_extendvnx2hivnx4qi */

    case 86:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5998; /* aarch64_ldnf1_extendvnx2hivnx2qi */

    case 87:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 6002; /* aarch64_ldnf1_extendvnx2hivnx4hi */

    case 88:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6006; /* aarch64_ldnf1_extendvnx2hivnx2hi */

    case 89:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6010; /* aarch64_ldnf1_extendvnx2hivnx2si */

    case 90:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 6014; /* aarch64_ldnf1_extendvnx4sivnx8qi */

    case 91:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6018; /* aarch64_ldnf1_extendvnx4sivnx4qi */

    case 92:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6022; /* aarch64_ldnf1_extendvnx4sivnx2qi */

    case 93:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6026; /* aarch64_ldnf1_extendvnx4sivnx4hi */

    case 94:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6030; /* aarch64_ldnf1_extendvnx4sivnx2hi */

    case 95:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6034; /* aarch64_ldnf1_extendvnx4sivnx2si */

    case 96:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6038; /* aarch64_ldnf1_extendvnx2sivnx8qi */

    case 97:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6042; /* aarch64_ldnf1_extendvnx2sivnx4qi */

    case 98:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6046; /* aarch64_ldnf1_extendvnx2sivnx2qi */

    case 99:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6050; /* aarch64_ldnf1_extendvnx2sivnx4hi */

    case 100:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6054; /* aarch64_ldnf1_extendvnx2sivnx2hi */

    case 101:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6058; /* aarch64_ldnf1_extendvnx2sivnx2si */

    case 102:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6062; /* aarch64_ldnf1_extendvnx2divnx8qi */

    case 103:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6066; /* aarch64_ldnf1_extendvnx2divnx4qi */

    case 104:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6070; /* aarch64_ldnf1_extendvnx2divnx2qi */

    case 105:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6074; /* aarch64_ldnf1_extendvnx2divnx4hi */

    case 106:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6078; /* aarch64_ldnf1_extendvnx2divnx2hi */

    case 107:
      if (!
#line 1435 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6082; /* aarch64_ldnf1_extendvnx2divnx2si */

    case 108:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5853; /* *aarch64_load_extend_movvnx8hivnx8qi */

    case 109:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5855; /* *aarch64_load_extend_movvnx8hivnx4qi */

    case 110:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5857; /* *aarch64_load_extend_movvnx8hivnx2qi */

    case 111:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5859; /* *aarch64_load_extend_movvnx8hivnx4hi */

    case 112:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5861; /* *aarch64_load_extend_movvnx8hivnx2hi */

    case 113:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5863; /* *aarch64_load_extend_movvnx8hivnx2si */

    case 114:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5865; /* *aarch64_load_extend_movvnx4hivnx8qi */

    case 115:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5867; /* *aarch64_load_extend_movvnx4hivnx4qi */

    case 116:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5869; /* *aarch64_load_extend_movvnx4hivnx2qi */

    case 117:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5871; /* *aarch64_load_extend_movvnx4hivnx4hi */

    case 118:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5873; /* *aarch64_load_extend_movvnx4hivnx2hi */

    case 119:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5875; /* *aarch64_load_extend_movvnx4hivnx2si */

    case 120:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5877; /* *aarch64_load_extend_movvnx2hivnx8qi */

    case 121:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5879; /* *aarch64_load_extend_movvnx2hivnx4qi */

    case 122:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5881; /* *aarch64_load_extend_movvnx2hivnx2qi */

    case 123:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5883; /* *aarch64_load_extend_movvnx2hivnx4hi */

    case 124:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5885; /* *aarch64_load_extend_movvnx2hivnx2hi */

    case 125:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5887; /* *aarch64_load_extend_movvnx2hivnx2si */

    case 126:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5889; /* *aarch64_load_extend_movvnx4sivnx8qi */

    case 127:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5891; /* *aarch64_load_extend_movvnx4sivnx4qi */

    case 128:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5893; /* *aarch64_load_extend_movvnx4sivnx2qi */

    case 129:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5895; /* *aarch64_load_extend_movvnx4sivnx4hi */

    case 130:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5897; /* *aarch64_load_extend_movvnx4sivnx2hi */

    case 131:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5899; /* *aarch64_load_extend_movvnx4sivnx2si */

    case 132:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5901; /* *aarch64_load_extend_movvnx2sivnx8qi */

    case 133:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5903; /* *aarch64_load_extend_movvnx2sivnx4qi */

    case 134:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5905; /* *aarch64_load_extend_movvnx2sivnx2qi */

    case 135:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5907; /* *aarch64_load_extend_movvnx2sivnx4hi */

    case 136:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5909; /* *aarch64_load_extend_movvnx2sivnx2hi */

    case 137:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5911; /* *aarch64_load_extend_movvnx2sivnx2si */

    case 138:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5913; /* *aarch64_load_extend_movvnx2divnx8qi */

    case 139:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5915; /* *aarch64_load_extend_movvnx2divnx4qi */

    case 140:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5917; /* *aarch64_load_extend_movvnx2divnx2qi */

    case 141:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5919; /* *aarch64_load_extend_movvnx2divnx4hi */

    case 142:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5921; /* *aarch64_load_extend_movvnx2divnx2hi */

    case 143:
      if (!
#line 1371 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5923; /* *aarch64_load_extend_movvnx2divnx2si */

    case 144:
      if (!
#line 1663 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6139; /* aarch64_gather_load_extendvnx4hivnx4qi */

    case 145:
      if (!
#line 1663 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6143; /* aarch64_gather_load_extendvnx4hivnx4hi */

    case 146:
      if (!
#line 1663 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6141; /* aarch64_gather_load_extendvnx4sivnx4qi */

    case 147:
      if (!
#line 1663 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6145; /* aarch64_gather_load_extendvnx4sivnx4hi */

    case 148:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6147; /* aarch64_gather_load_extendvnx2hivnx2qi */

    case 149:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6153; /* aarch64_gather_load_extendvnx2hivnx2hi */

    case 150:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6159; /* aarch64_gather_load_extendvnx2hivnx2si */

    case 151:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6149; /* aarch64_gather_load_extendvnx2sivnx2qi */

    case 152:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6155; /* aarch64_gather_load_extendvnx2sivnx2hi */

    case 153:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6161; /* aarch64_gather_load_extendvnx2sivnx2si */

    case 154:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6151; /* aarch64_gather_load_extendvnx2divnx2qi */

    case 155:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6157; /* aarch64_gather_load_extendvnx2divnx2hi */

    case 156:
      if (!
#line 1703 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6163; /* aarch64_gather_load_extendvnx2divnx2si */

    case 157:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6165; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw_unpacked */

    case 158:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6177; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw_unpacked */

    case 159:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6189; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw_unpacked */

    case 160:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6169; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw_unpacked */

    case 161:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6181; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw_unpacked */

    case 162:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6193; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw_unpacked */

    case 163:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6173; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw_unpacked */

    case 164:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6185; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw_unpacked */

    case 165:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6197; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw_unpacked */

    case 166:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6201; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw */

    case 167:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6207; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw */

    case 168:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6213; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw */

    case 169:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6203; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw */

    case 170:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6209; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw */

    case 171:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6215; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw */

    case 172:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6205; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw */

    case 173:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6211; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw */

    case 174:
      if (!
#line 1780 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6217; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw */

    case 175:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6167; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw_unpacked */

    case 176:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6179; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw_unpacked */

    case 177:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6191; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw_unpacked */

    case 178:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6171; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw_unpacked */

    case 179:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6183; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw_unpacked */

    case 180:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6195; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw_unpacked */

    case 181:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6175; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw_unpacked */

    case 182:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6187; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw_unpacked */

    case 183:
      if (!
#line 1742 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6199; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw_unpacked */

    case 184:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6219; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw */

    case 185:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6225; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw */

    case 186:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6231; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw */

    case 187:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6221; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw */

    case 188:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6227; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw */

    case 189:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6233; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw */

    case 190:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6223; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw */

    case 191:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6229; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw */

    case 192:
      if (!
#line 1815 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6235; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw */

    case 193:
      if (!
#line 1976 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6245; /* aarch64_ldff1_gather_extendvnx4sivnx4qi */

    case 194:
      if (!
#line 1976 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6247; /* aarch64_ldff1_gather_extendvnx4sivnx4hi */

    case 195:
      if (!
#line 2014 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6249; /* aarch64_ldff1_gather_extendvnx2divnx2qi */

    case 196:
      if (!
#line 2014 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6251; /* aarch64_ldff1_gather_extendvnx2divnx2hi */

    case 197:
      if (!
#line 2014 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6253; /* aarch64_ldff1_gather_extendvnx2divnx2si */

    case 198:
      if (!
#line 2052 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6255; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_sxtw */

    case 199:
      if (!
#line 2052 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6257; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_sxtw */

    case 200:
      if (!
#line 2052 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6259; /* *aarch64_ldff1_gather_extendvnx2divnx2si_sxtw */

    case 201:
      if (!
#line 2084 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6261; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_uxtw */

    case 202:
      if (!
#line 2084 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6263; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_uxtw */

    case 203:
      if (!
#line 2084 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6265; /* *aarch64_ldff1_gather_extendvnx2divnx2si_uxtw */

    case 204:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 11259; /* aarch64_gather_ldnt_extendvnx4sivnx8qi */

    case 205:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 11261; /* aarch64_gather_ldnt_extendvnx4sivnx4qi */

    case 206:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 11263; /* aarch64_gather_ldnt_extendvnx4sivnx2qi */

    case 207:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 11265; /* aarch64_gather_ldnt_extendvnx4sivnx4hi */

    case 208:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 11267; /* aarch64_gather_ldnt_extendvnx4sivnx2hi */

    case 209:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 11269; /* aarch64_gather_ldnt_extendvnx4sivnx2si */

    case 210:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 11271; /* aarch64_gather_ldnt_extendvnx2divnx8qi */

    case 211:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 11273; /* aarch64_gather_ldnt_extendvnx2divnx4qi */

    case 212:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 11275; /* aarch64_gather_ldnt_extendvnx2divnx2qi */

    case 213:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 11277; /* aarch64_gather_ldnt_extendvnx2divnx4hi */

    case 214:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 11279; /* aarch64_gather_ldnt_extendvnx2divnx2hi */

    case 215:
      if (!
#line 398 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 11281; /* aarch64_gather_ldnt_extendvnx2divnx2si */

    default:
      return -1;
    }
}

 int
recog_129 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12891; /* aarch64_sve_uzpqvnx32qi */

    case 1:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12893; /* aarch64_sve_uzpqvnx16hi */

    case 2:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12895; /* aarch64_sve_uzpqvnx8si */

    case 3:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12897; /* aarch64_sve_uzpqvnx4di */

    case 4:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12899; /* aarch64_sve_uzpqvnx16bf */

    case 5:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12901; /* aarch64_sve_uzpqvnx16hf */

    case 6:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12903; /* aarch64_sve_uzpqvnx8sf */

    case 7:
      if (!
#line 3885 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12905; /* aarch64_sve_uzpqvnx4df */

    default:
      return -1;
    }
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern122 (x1))
    {
    case 0:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10721; /* aarch64_sve_zip1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10727; /* aarch64_sve_zip1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10733; /* aarch64_sve_zip1qvnx4si */

    case 3:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10739; /* aarch64_sve_zip1qvnx2di */

    case 4:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10745; /* aarch64_sve_zip1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10751; /* aarch64_sve_zip1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10757; /* aarch64_sve_zip1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10763; /* aarch64_sve_zip1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_150 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      return 1041; /* scvtfsi3 */

    case 1:
      return 1043; /* scvtfdi3 */

    case 2:
      if (!
#line 7226 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1049; /* scvtfsihf3 */

    case 3:
      if (!
#line 7226 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1051; /* scvtfdihf3 */

    case 4:
      if (!
#line 7246 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1055; /* scvtfhi3 */

    case 5:
      if (!(
#line 3136 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 291 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2642; /* scvtfv4hi3 */

    case 6:
      if (!(
#line 3136 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 292 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2644; /* scvtfv8hi3 */

    case 7:
      if (!
#line 3136 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2646; /* scvtfv2si3 */

    case 8:
      if (!
#line 3136 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2648; /* scvtfv4si3 */

    case 9:
      if (!
#line 3136 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2650; /* scvtfv2di3 */

    default:
      return -1;
    }
}

 int
recog_161 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern128 (x1))
    {
    case 0:
      if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12144; /* aarch64_sve_umulltvnx8hi */

    case 1:
      if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12165; /* aarch64_sve_umulltvnx4si */

    case 2:
      if (!
#line 2270 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12186; /* aarch64_sve_umulltvnx2di */

    case 3:
      if (!
#line 2283 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12194; /* aarch64_sve_umullt_lane_vnx4si */

    case 4:
      if (!
#line 2283 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12200; /* aarch64_sve_umullt_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_171 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern134 (x1))
    {
    case 0:
      if (!
#line 3922 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12940; /* aarch64_sve_bgrpvnx16qi */

    case 1:
      if (!
#line 3922 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12943; /* aarch64_sve_bgrpvnx8hi */

    case 2:
      if (!
#line 3922 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12946; /* aarch64_sve_bgrpvnx4si */

    case 3:
      if (!
#line 3922 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12949; /* aarch64_sve_bgrpvnx2di */

    default:
      return -1;
    }
}

 int
recog_178 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern140 (x1))
    {
    case 0:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12774; /* aarch64_pred_reduc_orqv_vnx16qi */

    case 1:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12782; /* aarch64_pred_reduc_orqv_vnx8hi */

    case 2:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12790; /* aarch64_pred_reduc_orqv_vnx4si */

    case 3:
      if (!
#line 3723 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12798; /* aarch64_pred_reduc_orqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_188 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern120 (x1))
    {
    case 0:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10411; /* aarch64_pred_reduc_and_vnx16qi */

    case 1:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10418; /* aarch64_pred_reduc_and_vnx8hi */

    case 2:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10425; /* aarch64_pred_reduc_and_vnx4si */

    case 3:
      if (!
#line 8983 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10432; /* aarch64_pred_reduc_and_vnx2di */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x7, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      switch (pattern1202 (x2, 
E_VNx8HFmode))
        {
        case 0:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
            return -1;
          return 10966; /* *cond_fcvt_truncvnx4sfvnx8hf */

        case 1:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10967; /* *cond_fcvt_truncvnx2dfvnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      switch (pattern1202 (x2, 
E_VNx4SFmode))
        {
        case 0:
          if (!register_operand (operands[1], E_VNx4BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx4SFmode:
              if (!register_operand (operands[2], E_VNx4SFmode)
                  || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                return -1;
              return 10968; /* *cond_fcvt_truncvnx4sfvnx4sf */

            case E_VNx8HFmode:
              if (!register_operand (operands[2], E_VNx8HFmode)
                  || !
#line 9980 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                return -1;
              return 10977; /* *cond_fcvt_nontruncvnx8hfvnx4sf */

            default:
              return -1;
            }

        case 1:
          if (!register_operand (operands[1], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DFmode)
              || !
#line 9823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10969; /* *cond_fcvt_truncvnx2dfvnx4sf */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (pattern1162 (x2, 
E_VNx8BFmode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9880 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
        return -1;
      return 10971; /* *cond_fcvt_truncvnx4sfvnx8bf */

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || !register_operand (operands[1], E_VNx2BImode)
          || GET_MODE (x3) != E_VNx2DFmode
          || !aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8HFmode:
          if (!register_operand (operands[2], E_VNx8HFmode)
              || !
#line 9980 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
            return -1;
          return 10978; /* *cond_fcvt_nontruncvnx8hfvnx2df */

        case E_VNx4SFmode:
          if (!register_operand (operands[2], E_VNx4SFmode)
              || !
#line 9980 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
            return -1;
          return 10980; /* *cond_fcvt_nontruncvnx4sfvnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_206 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern872 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7235; /* *cond_ceilvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7301; /* *cond_ceilvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7246; /* *cond_ceilvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7312; /* *cond_ceilvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7257; /* *cond_ceilvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7323; /* *cond_ceilvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7268; /* *cond_ceilvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7334; /* *cond_ceilvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7279; /* *cond_ceilvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7345; /* *cond_ceilvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7290; /* *cond_ceilvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7356; /* *cond_ceilvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11698; /* *cond_uhsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11741; /* *cond_uhsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11781; /* *cond_uhsubvnx4si_any */
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11671; /* *cond_srshlvnx16qi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11719; /* *cond_srshlvnx16qi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11759; /* *cond_srshlvnx16qi_any */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11692; /* *cond_shsubvnx4si_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11736; /* *cond_shsubvnx4si_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11776; /* *cond_shsubvnx4si_any */
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1061 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8536; /* *cond_fminvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8682; /* *cond_fminvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8786; /* *cond_fminvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8549; /* *cond_fminvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8695; /* *cond_fminvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8799; /* *cond_fminvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8562; /* *cond_fminvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8708; /* *cond_fminvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8812; /* *cond_fminvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8575; /* *cond_fminvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8721; /* *cond_fminvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8825; /* *cond_fminvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8636; /* *cond_fminvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8886; /* *cond_fminvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8643; /* *cond_fminvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8893; /* *cond_fminvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8650; /* *cond_fminvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8900; /* *cond_fminvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8588; /* *cond_fminvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8734; /* *cond_fminvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8838; /* *cond_fminvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8601; /* *cond_fminvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8747; /* *cond_fminvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8851; /* *cond_fminvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8614; /* *cond_fminvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8760; /* *cond_fminvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8864; /* *cond_fminvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8627; /* *cond_fminvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8773; /* *cond_fminvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8877; /* *cond_fminvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8657; /* *cond_fminvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8907; /* *cond_fminvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8664; /* *cond_fminvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8914; /* *cond_fminvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8671; /* *cond_fminvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8921; /* *cond_fminvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1126 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9266; /* *cond_fmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9294; /* *cond_fmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9326; /* *cond_fmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9270; /* *cond_fmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9298; /* *cond_fmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9330; /* *cond_fmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9274; /* *cond_fmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9302; /* *cond_fmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9334; /* *cond_fmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7554 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9290; /* *cond_fmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7600 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9322; /* *cond_fmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9278; /* *cond_fmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9310; /* *cond_fmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9342; /* *cond_fmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9282; /* *cond_fmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9314; /* *cond_fmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9346; /* *cond_fmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9286; /* *cond_fmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9318; /* *cond_fmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9350; /* *cond_fmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7578 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9306; /* *cond_fmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7646 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9338; /* *cond_fmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_272 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      switch (GET_CODE (operands[3]))
        {
        case CONST_VECTOR:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1063 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7100; /* *cond_uxtvnx16qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7110; /* *cond_uxtvnx16qi_any */

            case E_VNx8QImode:
              if (pattern1063 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7101; /* *cond_uxtvnx8qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7111; /* *cond_uxtvnx8qi_any */

            case E_VNx4QImode:
              if (pattern1063 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7102; /* *cond_uxtvnx4qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7112; /* *cond_uxtvnx4qi_any */

            case E_VNx2QImode:
              if (pattern1063 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7103; /* *cond_uxtvnx2qi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7113; /* *cond_uxtvnx2qi_any */

            case E_VNx8HImode:
              if (pattern1063 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7104; /* *cond_uxtvnx8hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7114; /* *cond_uxtvnx8hi_any */

            case E_VNx4HImode:
              if (pattern1063 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7105; /* *cond_uxtvnx4hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7115; /* *cond_uxtvnx4hi_any */

            case E_VNx2HImode:
              if (pattern1063 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7106; /* *cond_uxtvnx2hi_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7116; /* *cond_uxtvnx2hi_any */

            case E_VNx4SImode:
              if (pattern1063 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7107; /* *cond_uxtvnx4si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7117; /* *cond_uxtvnx4si_any */

            case E_VNx2SImode:
              if (pattern1063 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7108; /* *cond_uxtvnx2si_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7118; /* *cond_uxtvnx2si_any */

            case E_VNx2DImode:
              if (pattern1063 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 3412 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7109; /* *cond_uxtvnx2di_2 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 3436 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
                return -1;
              return 7119; /* *cond_uxtvnx2di_any */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern484 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7484; /* *cond_andvnx16qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7654; /* *cond_andvnx16qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7824; /* *cond_andvnx16qi_any */

            case E_VNx8QImode:
              if (pattern484 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7501; /* *cond_andvnx8qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7671; /* *cond_andvnx8qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7841; /* *cond_andvnx8qi_any */

            case E_VNx4QImode:
              if (pattern484 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7518; /* *cond_andvnx4qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7688; /* *cond_andvnx4qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7858; /* *cond_andvnx4qi_any */

            case E_VNx2QImode:
              if (pattern484 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7535; /* *cond_andvnx2qi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7705; /* *cond_andvnx2qi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7875; /* *cond_andvnx2qi_any */

            case E_VNx8HImode:
              if (pattern484 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7552; /* *cond_andvnx8hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7722; /* *cond_andvnx8hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7892; /* *cond_andvnx8hi_any */

            case E_VNx4HImode:
              if (pattern484 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7569; /* *cond_andvnx4hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7739; /* *cond_andvnx4hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7909; /* *cond_andvnx4hi_any */

            case E_VNx2HImode:
              if (pattern484 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7586; /* *cond_andvnx2hi_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7756; /* *cond_andvnx2hi_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7926; /* *cond_andvnx2hi_any */

            case E_VNx4SImode:
              if (pattern484 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7603; /* *cond_andvnx4si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7773; /* *cond_andvnx4si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7943; /* *cond_andvnx4si_any */

            case E_VNx2SImode:
              if (pattern484 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7620; /* *cond_andvnx2si_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7790; /* *cond_andvnx2si_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7960; /* *cond_andvnx2si_any */

            case E_VNx2DImode:
              if (pattern484 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              x7 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x7, operands[2])
                  && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7637; /* *cond_andvnx2di_2 */
              if (rtx_equal_p (x7, operands[3])
                  && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 7807; /* *cond_andvnx2di_3 */
              operands[4] = x7;
              if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
                  || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 7977; /* *cond_andvnx2di_any */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1000 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8210; /* *cond_bicvnx16qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8220; /* *cond_bicvnx16qi_any */

        case E_VNx8QImode:
          if (pattern1000 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8211; /* *cond_bicvnx8qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8221; /* *cond_bicvnx8qi_any */

        case E_VNx4QImode:
          if (pattern1000 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8212; /* *cond_bicvnx4qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8222; /* *cond_bicvnx4qi_any */

        case E_VNx2QImode:
          if (pattern1000 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8213; /* *cond_bicvnx2qi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8223; /* *cond_bicvnx2qi_any */

        case E_VNx8HImode:
          if (pattern1000 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8214; /* *cond_bicvnx8hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8224; /* *cond_bicvnx8hi_any */

        case E_VNx4HImode:
          if (pattern1000 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8215; /* *cond_bicvnx4hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8225; /* *cond_bicvnx4hi_any */

        case E_VNx2HImode:
          if (pattern1000 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8216; /* *cond_bicvnx2hi_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8226; /* *cond_bicvnx2hi_any */

        case E_VNx4SImode:
          if (pattern1000 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8217; /* *cond_bicvnx4si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8227; /* *cond_bicvnx4si_any */

        case E_VNx2SImode:
          if (pattern1000 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8218; /* *cond_bicvnx2si_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8228; /* *cond_bicvnx2si_any */

        case E_VNx2DImode:
          if (pattern1000 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4789 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8219; /* *cond_bicvnx2di_2 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4807 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8229; /* *cond_bicvnx2di_any */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_284 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern734 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7486; /* *cond_xorvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7656; /* *cond_xorvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7826; /* *cond_xorvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7503; /* *cond_xorvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7673; /* *cond_xorvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7843; /* *cond_xorvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7520; /* *cond_xorvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7690; /* *cond_xorvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7860; /* *cond_xorvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7537; /* *cond_xorvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7707; /* *cond_xorvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7877; /* *cond_xorvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7554; /* *cond_xorvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7724; /* *cond_xorvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7894; /* *cond_xorvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7571; /* *cond_xorvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7741; /* *cond_xorvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7911; /* *cond_xorvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7588; /* *cond_xorvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7758; /* *cond_xorvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7928; /* *cond_xorvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7605; /* *cond_xorvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7775; /* *cond_xorvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7945; /* *cond_xorvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7622; /* *cond_xorvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7792; /* *cond_xorvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7962; /* *cond_xorvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7639; /* *cond_xorvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7809; /* *cond_xorvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7979; /* *cond_xorvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_293 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern610 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6737; /* *cond_rbitvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6827; /* *cond_rbitvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6746; /* *cond_rbitvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6836; /* *cond_rbitvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6755; /* *cond_rbitvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6845; /* *cond_rbitvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6764; /* *cond_rbitvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6854; /* *cond_rbitvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6773; /* *cond_rbitvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6863; /* *cond_rbitvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6782; /* *cond_rbitvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6872; /* *cond_rbitvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6791; /* *cond_rbitvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6881; /* *cond_rbitvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6800; /* *cond_rbitvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6890; /* *cond_rbitvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6809; /* *cond_rbitvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6899; /* *cond_rbitvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6818; /* *cond_rbitvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3250 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6908; /* *cond_rbitvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern798 (x3, 
E_V8QImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5008; /* aarch64_extv8qi */

    case E_V16QImode:
      if (pattern798 (x3, 
E_V16QImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5009; /* aarch64_extv16qi */

    case E_V4HImode:
      if (pattern798 (x3, 
E_V4HImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5010; /* aarch64_extv4hi */

    case E_V8HImode:
      if (pattern798 (x3, 
E_V8HImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5011; /* aarch64_extv8hi */

    case E_V2SImode:
      if (pattern798 (x3, 
E_V2SImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5012; /* aarch64_extv2si */

    case E_V4SImode:
      if (pattern798 (x3, 
E_V4SImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5013; /* aarch64_extv4si */

    case E_V2DImode:
      if (pattern798 (x3, 
E_V2DImode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5014; /* aarch64_extv2di */

    case E_V4HFmode:
      if (pattern798 (x3, 
E_V4HFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5015; /* aarch64_extv4hf */

    case E_V8HFmode:
      if (pattern798 (x3, 
E_V8HFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5016; /* aarch64_extv8hf */

    case E_V4BFmode:
      if (pattern798 (x3, 
E_V4BFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5017; /* aarch64_extv4bf */

    case E_V8BFmode:
      if (pattern798 (x3, 
E_V8BFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5018; /* aarch64_extv8bf */

    case E_V2SFmode:
      if (pattern798 (x3, 
E_V2SFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5019; /* aarch64_extv2sf */

    case E_V4SFmode:
      if (pattern798 (x3, 
E_V4SFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5020; /* aarch64_extv4sf */

    case E_V2DFmode:
      if (pattern798 (x3, 
E_V2DFmode) != 0
          || !
#line 8661 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5021; /* aarch64_extv2df */

    case E_VNx16QImode:
      if (pattern799 (x3, 
E_VNx16QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 8 / 8, 0, 255)))
        return -1;
      return 10769; /* aarch64_sve_extvnx16qi */

    case E_VNx8QImode:
      if (pattern799 (x3, 
E_VNx8QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10770; /* aarch64_sve_extvnx8qi */

    case E_VNx4QImode:
      if (pattern799 (x3, 
E_VNx4QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10771; /* aarch64_sve_extvnx4qi */

    case E_VNx2QImode:
      if (pattern799 (x3, 
E_VNx2QImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10772; /* aarch64_sve_extvnx2qi */

    case E_VNx8HImode:
      if (pattern799 (x3, 
E_VNx8HImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10773; /* aarch64_sve_extvnx8hi */

    case E_VNx4HImode:
      if (pattern799 (x3, 
E_VNx4HImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10774; /* aarch64_sve_extvnx4hi */

    case E_VNx2HImode:
      if (pattern799 (x3, 
E_VNx2HImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10775; /* aarch64_sve_extvnx2hi */

    case E_VNx4SImode:
      if (pattern799 (x3, 
E_VNx4SImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10776; /* aarch64_sve_extvnx4si */

    case E_VNx2SImode:
      if (pattern799 (x3, 
E_VNx2SImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10777; /* aarch64_sve_extvnx2si */

    case E_VNx2DImode:
      if (pattern799 (x3, 
E_VNx2DImode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10778; /* aarch64_sve_extvnx2di */

    case E_VNx8HFmode:
      if (pattern799 (x3, 
E_VNx8HFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10779; /* aarch64_sve_extvnx8hf */

    case E_VNx4HFmode:
      if (pattern799 (x3, 
E_VNx4HFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10780; /* aarch64_sve_extvnx4hf */

    case E_VNx2HFmode:
      if (pattern799 (x3, 
E_VNx2HFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10781; /* aarch64_sve_extvnx2hf */

    case E_VNx8BFmode:
      if (pattern799 (x3, 
E_VNx8BFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 16 / 8, 0, 255)))
        return -1;
      return 10782; /* aarch64_sve_extvnx8bf */

    case E_VNx4BFmode:
      if (pattern799 (x3, 
E_VNx4BFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10783; /* aarch64_sve_extvnx4bf */

    case E_VNx2BFmode:
      if (pattern799 (x3, 
E_VNx2BFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10784; /* aarch64_sve_extvnx2bf */

    case E_VNx4SFmode:
      if (pattern799 (x3, 
E_VNx4SFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 32 / 8, 0, 255)))
        return -1;
      return 10785; /* aarch64_sve_extvnx4sf */

    case E_VNx2SFmode:
      if (pattern799 (x3, 
E_VNx2SFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10786; /* aarch64_sve_extvnx2sf */

    case E_VNx2DFmode:
      if (pattern799 (x3, 
E_VNx2DFmode) != 0
          || !
#line 9240 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[3]) * 64 / 8, 0, 255)))
        return -1;
      return 10787; /* aarch64_sve_extvnx2df */

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      switch (pattern797 (x3, 
E_V8QImode))
        {
        case 0:
          if (!
#line 8536 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4829; /* aarch64_qtbx1v8qi */

        case 1:
          if (!
#line 8559 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4833; /* aarch64_qtbx2v8qi */

        case 2:
          if (!
#line 8582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4837; /* aarch64_qtbx3v8qi */

        case 3:
          if (!
#line 8605 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4841; /* aarch64_qtbx4v8qi */

        default:
          return -1;
        }

    case E_V16QImode:
      switch (pattern797 (x3, 
E_V16QImode))
        {
        case 0:
          if (!
#line 8536 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4830; /* aarch64_qtbx1v16qi */

        case 1:
          if (!
#line 8559 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4834; /* aarch64_qtbx2v16qi */

        case 2:
          if (!
#line 8582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4838; /* aarch64_qtbx3v16qi */

        case 3:
          if (!
#line 8605 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4842; /* aarch64_qtbx4v16qi */

        default:
          return -1;
        }

    case E_VNx16QImode:
      if (pattern199 (x3, 
E_VNx16QImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12858; /* aarch64_sve_tbxvnx16qi */

    case E_VNx8HImode:
      if (pattern199 (x3, 
E_VNx8HImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12860; /* aarch64_sve_tbxvnx8hi */

    case E_VNx4SImode:
      if (pattern199 (x3, 
E_VNx4SImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12862; /* aarch64_sve_tbxvnx4si */

    case E_VNx2DImode:
      if (pattern199 (x3, 
E_VNx2DImode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12864; /* aarch64_sve_tbxvnx2di */

    case E_VNx8BFmode:
      if (pattern796 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12866; /* aarch64_sve_tbxvnx8bf */

    case E_VNx8HFmode:
      if (pattern796 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12868; /* aarch64_sve_tbxvnx8hf */

    case E_VNx4SFmode:
      if (pattern796 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12870; /* aarch64_sve_tbxvnx4sf */

    case E_VNx2DFmode:
      if (pattern796 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !
#line 3857 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12872; /* aarch64_sve_tbxvnx2df */

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9977; /* while_ugtsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9987; /* while_ugtdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9997; /* while_ugtsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10007; /* while_ugtdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10017; /* while_ugtsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10027; /* while_ugtdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10037; /* while_ugtsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10047; /* while_ugtdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern77 (x3, 
E_VNx16QImode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (8 / 8), 0, 15)))
        return -1;
      return 12842; /* aarch64_sve_extqvnx16qi */

    case E_VNx8HImode:
      if (pattern77 (x3, 
E_VNx8HImode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (16 / 8), 0, 15)))
        return -1;
      return 12843; /* aarch64_sve_extqvnx8hi */

    case E_VNx4SImode:
      if (pattern77 (x3, 
E_VNx4SImode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (32 / 8), 0, 15)))
        return -1;
      return 12844; /* aarch64_sve_extqvnx4si */

    case E_VNx2DImode:
      if (pattern77 (x3, 
E_VNx2DImode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (64 / 8), 0, 15)))
        return -1;
      return 12845; /* aarch64_sve_extqvnx2di */

    case E_VNx8BFmode:
      if (pattern77 (x3, 
E_VNx8BFmode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (16 / 8), 0, 15)))
        return -1;
      return 12846; /* aarch64_sve_extqvnx8bf */

    case E_VNx8HFmode:
      if (pattern77 (x3, 
E_VNx8HFmode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (16 / 8), 0, 15)))
        return -1;
      return 12847; /* aarch64_sve_extqvnx8hf */

    case E_VNx4SFmode:
      if (pattern77 (x3, 
E_VNx4SFmode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (32 / 8), 0, 15)))
        return -1;
      return 12848; /* aarch64_sve_extqvnx4sf */

    case E_VNx2DFmode:
      if (pattern77 (x3, 
E_VNx2DFmode) != 0
          || !
#line 3817 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1
   && TARGET_NON_STREAMING
   && IN_RANGE (INTVAL (operands[3]) * (64 / 8), 0, 15)))
        return -1;
      return 12849; /* aarch64_sve_extqvnx2df */

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern196 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10523; /* aarch64_sve_splicevnx16qi */

    case E_VNx8HImode:
      if (pattern196 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10524; /* aarch64_sve_splicevnx8hi */

    case E_VNx4SImode:
      if (pattern196 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10525; /* aarch64_sve_splicevnx4si */

    case E_VNx2DImode:
      if (pattern196 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10526; /* aarch64_sve_splicevnx2di */

    case E_VNx8BFmode:
      if (pattern196 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10527; /* aarch64_sve_splicevnx8bf */

    case E_VNx8HFmode:
      if (pattern196 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10528; /* aarch64_sve_splicevnx8hf */

    case E_VNx4SFmode:
      if (pattern196 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10529; /* aarch64_sve_splicevnx4sf */

    case E_VNx2DFmode:
      if (pattern196 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 9200 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10530; /* aarch64_sve_splicevnx2df */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern182 (x1))
    {
    case 0:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
        return -1;
      return 10904; /* aarch64_sve_float_nonextendvnx8hivnx8hf */

    case 1:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10910; /* aarch64_sve_float_nonextendvnx4sivnx8hf */

    case 2:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 10916; /* aarch64_sve_float_nonextendvnx2divnx8hf */

    case 3:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
        return -1;
      return 10906; /* aarch64_sve_float_nonextendvnx8hivnx4sf */

    case 4:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10912; /* aarch64_sve_float_nonextendvnx4sivnx4sf */

    case 5:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 10918; /* aarch64_sve_float_nonextendvnx2divnx4sf */

    case 6:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
        return -1;
      return 10908; /* aarch64_sve_float_nonextendvnx8hivnx2df */

    case 7:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10914; /* aarch64_sve_float_nonextendvnx4sivnx2df */

    case 8:
      if (!
#line 9592 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 10920; /* aarch64_sve_float_nonextendvnx2divnx2df */

    case 9:
      if (!
#line 9607 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10922; /* aarch64_sve_float_extendvnx4sivnx2df */

    default:
      return -1;
    }
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3829; /* aarch64_usli_nv8qi */

    case 1:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3833; /* aarch64_usli_nv16qi */

    case 2:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3837; /* aarch64_usli_nv4hi */

    case 3:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3841; /* aarch64_usli_nv8hi */

    case 4:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3845; /* aarch64_usli_nv2si */

    case 5:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3849; /* aarch64_usli_nv4si */

    case 6:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3853; /* aarch64_usli_nv2di */

    case 7:
      if (!
#line 6655 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3857; /* aarch64_usli_ndi */

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern201 (x1))
    {
    case 0:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12568; /* aarch64_sve_cmla270vnx16qi */

    case 1:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12576; /* aarch64_sve_cmla270vnx8hi */

    case 2:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12584; /* aarch64_sve_cmla270vnx4si */

    case 3:
      if (!
#line 3016 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12592; /* aarch64_sve_cmla270vnx2di */

    case 4:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12600; /* aarch64_cmla270_lane_vnx8hi */

    case 5:
      if (!
#line 3033 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12608; /* aarch64_cmla270_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_368 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern196 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 3986 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 12950; /* aarch64_sve2_histcntvnx4si */

    case E_VNx2DImode:
      if (pattern196 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 3986 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2 && TARGET_NON_STREAMING))
        return -1;
      return 12951; /* aarch64_sve2_histcntvnx2di */

    default:
      return -1;
    }
}

 int
recog_375 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern197 (x1))
    {
    case 0:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12498; /* aarch64_pred_sminpvnx16qi */

    case 1:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12503; /* aarch64_pred_sminpvnx8hi */

    case 2:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12508; /* aarch64_pred_sminpvnx4si */

    case 3:
      if (!
#line 2821 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12513; /* aarch64_pred_sminpvnx2di */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern191 (x1))
    {
    case 0:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11875; /* aarch64_sve_adclbvnx16qi */

    case 1:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11883; /* aarch64_sve_adclbvnx8hi */

    case 2:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11891; /* aarch64_sve_adclbvnx4si */

    case 3:
      if (!
#line 1451 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11899; /* aarch64_sve_adclbvnx2di */

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10140; /* while_wrsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10150; /* while_wrdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10160; /* while_wrsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10170; /* while_wrdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10180; /* while_wrsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10190; /* while_wrdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10200; /* while_wrsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3456 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10210; /* while_wrdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern227 (x1))
    {
    case 0:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13201; /* aarch64_sme_read_horvnx32qivnx32qi */

    case 1:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13203; /* aarch64_sme_read_horvnx16hivnx16hi */

    case 2:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13205; /* aarch64_sme_read_horvnx8sivnx8si */

    case 3:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13207; /* aarch64_sme_read_horvnx4divnx4di */

    case 4:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13209; /* aarch64_sme_read_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13211; /* aarch64_sme_read_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13213; /* aarch64_sme_read_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13215; /* aarch64_sme_read_horvnx4dfvnx4df */

    case 8:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13217; /* aarch64_sme_read_horvnx64qivnx64qi */

    case 9:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13219; /* aarch64_sme_read_horvnx32hivnx32hi */

    case 10:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13221; /* aarch64_sme_read_horvnx16sivnx16si */

    case 11:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13223; /* aarch64_sme_read_horvnx8divnx8di */

    case 12:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13225; /* aarch64_sme_read_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13227; /* aarch64_sme_read_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13229; /* aarch64_sme_read_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 827 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13231; /* aarch64_sme_read_horvnx8dfvnx8df */

    case 16:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 8))
        return -1;
      return 13233; /* *aarch64_sme_read_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13235; /* *aarch64_sme_read_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13237; /* *aarch64_sme_read_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13239; /* *aarch64_sme_read_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13241; /* *aarch64_sme_read_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13243; /* *aarch64_sme_read_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13245; /* *aarch64_sme_read_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 2 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13247; /* *aarch64_sme_read_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 8))
        return -1;
      return 13249; /* *aarch64_sme_read_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13251; /* *aarch64_sme_read_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13253; /* *aarch64_sme_read_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13255; /* *aarch64_sme_read_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13257; /* *aarch64_sme_read_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 16))
        return -1;
      return 13259; /* *aarch64_sme_read_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 32))
        return -1;
      return 13261; /* *aarch64_sme_read_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 844 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[3]) % 4 == 0
   && UINTVAL (operands[3]) < 128 / 64))
        return -1;
      return 13263; /* *aarch64_sme_read_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_415 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern220 (x1))
    {
    case 0:
      if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10215; /* aarch64_pred_fcmltvnx8hf */

    case 1:
      if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10221; /* aarch64_pred_fcmltvnx4sf */

    case 2:
      if (!
#line 8512 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10227; /* aarch64_pred_fcmltvnx2df */

    case 3:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 2);
      x4 = XVECEXP (x3, 0, 1);
      if (XWINT (x4, 0) == 0L)
        {
          switch (pattern1263 (x2))
            {
            case 0:
              if (
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10298; /* *aarch64_pred_facltvnx8hf_relaxed */
              break;

            case 1:
              if (
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10302; /* *aarch64_pred_facltvnx4sf_relaxed */
              break;

            case 2:
              if (
#line 8785 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10306; /* *aarch64_pred_facltvnx2df_relaxed */
              break;

            default:
              break;
            }
        }
      operands[5] = x4;
      switch (pattern1264 (x2))
        {
        case 0:
          if (!
#line 8811 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10310; /* *aarch64_pred_facltvnx8hf_strict */

        case 1:
          if (!
#line 8811 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10314; /* *aarch64_pred_facltvnx4sf_strict */

        case 2:
          if (!
#line 8811 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10318; /* *aarch64_pred_facltvnx2df_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern951 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6494 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9009; /* aarch64_pred_mulvnx8hf */

    case E_VNx4SFmode:
      if (pattern951 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6494 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9010; /* aarch64_pred_mulvnx4sf */

    case E_VNx2DFmode:
      if (pattern951 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6494 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9011; /* aarch64_pred_mulvnx2df */

    case E_VNx8BFmode:
      if (pattern208 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1347 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 11854; /* aarch64_pred_mulvnx8bf */

    default:
      return -1;
    }
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern254 (x1))
    {
    case 0:
      if (!
#line 1429 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13742; /* aarch64_sme_umlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1429 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13746; /* aarch64_sme_umlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13758; /* aarch64_sme_umlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13762; /* aarch64_sme_umlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13766; /* aarch64_sme_umlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1459 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13770; /* aarch64_sme_umlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1557 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13870; /* aarch64_sme_umlsvnx2divnx8hi */

    case 7:
      if (!
#line 1587 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13878; /* aarch64_sme_umlsvnx2divnx16hi */

    case 8:
      if (!
#line 1587 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13882; /* aarch64_sme_umlsvnx2divnx32hi */

    case 9:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13790; /* aarch64_sme_single_umlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13794; /* aarch64_sme_single_umlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13798; /* aarch64_sme_single_umlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1490 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13802; /* aarch64_sme_single_umlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1618 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13894; /* aarch64_sme_single_umlsvnx2divnx16hi */

    case 14:
      if (!
#line 1618 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13898; /* aarch64_sme_single_umlsvnx2divnx32hi */

    case 15:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13822; /* aarch64_sme_lane_umlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13826; /* aarch64_sme_lane_umlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13830; /* aarch64_sme_lane_umlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13834; /* aarch64_sme_lane_umlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13838; /* aarch64_sme_lane_umlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1524 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13842; /* aarch64_sme_lane_umlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13910; /* aarch64_sme_lane_umlsvnx2divnx8hi */

    case 22:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13914; /* aarch64_sme_lane_umlsvnx2divnx16hi */

    case 23:
      if (!
#line 1652 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13918; /* aarch64_sme_lane_umlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1443 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13750; /* *aarch64_sme_umlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1443 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13754; /* *aarch64_sme_umlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1325 ())
            {
            case 0:
              if (
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13774; /* *aarch64_sme_umlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13778; /* *aarch64_sme_umlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13782; /* *aarch64_sme_umlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1473 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13786; /* *aarch64_sme_umlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1571 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13874; /* *aarch64_sme_umlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1326 ())
        {
        case 0:
          if (!
#line 1601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13886; /* *aarch64_sme_umlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1601 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13890; /* *aarch64_sme_umlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1327 (x3))
            {
            case 0:
              if (
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13806; /* *aarch64_sme_single_umlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13810; /* *aarch64_sme_single_umlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern253 (x3))
        {
        case 0:
          if (!
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13814; /* *aarch64_sme_single_umlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1505 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13818; /* *aarch64_sme_single_umlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1633 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13902; /* *aarch64_sme_single_umlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1633 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13906; /* *aarch64_sme_single_umlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13846; /* *aarch64_sme_lane_umlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1365 (x3))
                {
                case 0:
                  if (
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13850; /* *aarch64_sme_lane_umlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13854; /* *aarch64_sme_lane_umlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13858; /* *aarch64_sme_lane_umlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1366 (x3))
        {
        case 0:
          if (!
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13862; /* *aarch64_sme_lane_umlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1541 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13866; /* *aarch64_sme_lane_umlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13922; /* *aarch64_sme_lane_umlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1366 (x3))
        {
        case 0:
          if (!
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13926; /* *aarch64_sme_lane_umlsvnx2divnx16hi */

        case 1:
          if (!
#line 1669 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13930; /* *aarch64_sme_lane_umlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (pattern262 (x2, 
89, 
E_V8DImode, 
94) != 0)
    return -1;
  x3 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 2L:
      switch (pattern1230 (x2))
        {
        case 0:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14157; /* aarch64_sme_lut2vnx16qi */

        case 1:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14159; /* aarch64_sme_lut2vnx8hi */

        case 2:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14161; /* aarch64_sme_lut2vnx4si */

        case 3:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14163; /* aarch64_sme_lut2vnx8bf */

        case 4:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14165; /* aarch64_sme_lut2vnx8hf */

        case 5:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14167; /* aarch64_sme_lut2vnx4sf */

        case 6:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 8 == 8)))
            return -1;
          return 14169; /* aarch64_sme_lut2vnx32qi */

        case 7:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14171; /* aarch64_sme_lut2vnx16hi */

        case 8:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14173; /* aarch64_sme_lut2vnx8si */

        case 9:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14175; /* aarch64_sme_lut2vnx16bf */

        case 10:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14177; /* aarch64_sme_lut2vnx16hf */

        case 11:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14179; /* aarch64_sme_lut2vnx8sf */

        case 12:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 8 == 8)))
            return -1;
          return 14181; /* aarch64_sme_lut2vnx64qi */

        case 13:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14183; /* aarch64_sme_lut2vnx32hi */

        case 14:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14185; /* aarch64_sme_lut2vnx16si */

        case 15:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14187; /* aarch64_sme_lut2vnx32bf */

        case 16:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14189; /* aarch64_sme_lut2vnx32hf */

        case 17:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(2 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14191; /* aarch64_sme_lut2vnx16sf */

        default:
          return -1;
        }

    case 4L:
      switch (pattern1230 (x2))
        {
        case 0:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14158; /* aarch64_sme_lut4vnx16qi */

        case 1:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14160; /* aarch64_sme_lut4vnx8hi */

        case 2:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14162; /* aarch64_sme_lut4vnx4si */

        case 3:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14164; /* aarch64_sme_lut4vnx8bf */

        case 4:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14166; /* aarch64_sme_lut4vnx8hf */

        case 5:
          if (!
#line 2150 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 14168; /* aarch64_sme_lut4vnx4sf */

        case 6:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 8 == 8)))
            return -1;
          return 14170; /* aarch64_sme_lut4vnx32qi */

        case 7:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14172; /* aarch64_sme_lut4vnx16hi */

        case 8:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14174; /* aarch64_sme_lut4vnx8si */

        case 9:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14176; /* aarch64_sme_lut4vnx16bf */

        case 10:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 16 == 8)))
            return -1;
          return 14178; /* aarch64_sme_lut4vnx16hf */

        case 11:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 2 == 4 && 32 == 8)))
            return -1;
          return 14180; /* aarch64_sme_lut4vnx8sf */

        case 12:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 8 == 8)))
            return -1;
          return 14182; /* aarch64_sme_lut4vnx64qi */

        case 13:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14184; /* aarch64_sme_lut4vnx32hi */

        case 14:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14186; /* aarch64_sme_lut4vnx16si */

        case 15:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14188; /* aarch64_sme_lut4vnx32bf */

        case 16:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 16 == 8)))
            return -1;
          return 14190; /* aarch64_sme_lut4vnx32hf */

        case 17:
          if (!
#line 2163 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && !(4 == 4 && 4 == 4 && 32 == 8)))
            return -1;
          return 14192; /* aarch64_sme_lut4vnx16sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_447 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 156:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern796 (x2, 
E_V4SImode, 
E_SFmode) != 0
              || !
#line 7499 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
            return -1;
          return 1110; /* copysignsf3_insn */

        case E_DFmode:
          if (pattern796 (x2, 
E_V2DImode, 
E_DFmode) != 0
              || !
#line 7499 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
            return -1;
          return 1111; /* copysigndf3_insn */

        default:
          return -1;
        }

    case 76:
      return recog_365 (x1, insn, pnum_clobbers);

    case 275:
      return recog_314 (x1, insn, pnum_clobbers);

    case 276:
      return recog_313 (x1, insn, pnum_clobbers);

    case 222:
      if (pattern152 (x1) != 0
          || !
#line 6641 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3826; /* aarch64_ssra_ndi */

    case 223:
      if (pattern152 (x1) != 0
          || !
#line 6641 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3827; /* aarch64_usra_ndi */

    case 235:
      return recog_352 (x1, insn, pnum_clobbers);

    case 236:
      return recog_351 (x1, insn, pnum_clobbers);

    case 237:
      return recog_350 (x1, insn, pnum_clobbers);

    case 238:
      return recog_349 (x1, insn, pnum_clobbers);

    case 60:
      return recog_302 (x1, insn, pnum_clobbers);

    case 61:
      return recog_301 (x1, insn, pnum_clobbers);

    case 62:
      return recog_300 (x1, insn, pnum_clobbers);

    case 182:
      return recog_325 (x1, insn, pnum_clobbers);

    case 244:
      return recog_312 (x1, insn, pnum_clobbers);

    case 253:
      return recog_299 (x1, insn, pnum_clobbers);

    case 261:
      if (pattern163 (x1) != 0
          || !
#line 9026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5185; /* aarch64_crypto_sha1cv4si */

    case 262:
      if (pattern163 (x1) != 0
          || !
#line 9026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5186; /* aarch64_crypto_sha1mv4si */

    case 263:
      if (pattern163 (x1) != 0
          || !
#line 9026 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5187; /* aarch64_crypto_sha1pv4si */

    case 265:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9037 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5188; /* aarch64_crypto_sha1su0v4si */

    case 267:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9050 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5189; /* aarch64_crypto_sha256hv4si */

    case 268:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9050 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5190; /* aarch64_crypto_sha256h2v4si */

    case 270:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9071 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA2))
        return -1;
      return 5192; /* aarch64_crypto_sha256su1v4si */

    case 290:
      if (pattern164 (x1, 
E_V2DImode) != 0
          || !
#line 9084 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
        return -1;
      return 5193; /* aarch64_crypto_sha512hqv2di */

    case 291:
      if (pattern164 (x1, 
E_V2DImode) != 0
          || !
#line 9084 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
        return -1;
      return 5194; /* aarch64_crypto_sha512h2qv2di */

    case 293:
      if (pattern164 (x1, 
E_V2DImode) != 0
          || !
#line 9105 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SHA3))
        return -1;
      return 5196; /* aarch64_crypto_sha512su1qv2di */

    case 281:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9193 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5207; /* aarch64_sm3ss1qv4si */

    case 286:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9217 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5212; /* aarch64_sm3partw1qv4si */

    case 287:
      if (pattern164 (x1, 
E_V4SImode) != 0
          || !
#line 9217 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5213; /* aarch64_sm3partw2qv4si */

    case 188:
      return recog_340 (x1, insn, pnum_clobbers);

    case 115:
      return recog_309 (x1, insn, pnum_clobbers);

    case 146:
      return recog_306 (x1, insn, pnum_clobbers);

    case 403:
      return recog_338 (x1, insn, pnum_clobbers);

    case 404:
      return recog_337 (x1, insn, pnum_clobbers);

    case 117:
      return recog_336 (x1, insn, pnum_clobbers);

    case 116:
      return recog_304 (x1, insn, pnum_clobbers);

    case 147:
      return recog_305 (x1, insn, pnum_clobbers);

    case 118:
      return recog_328 (x1, insn, pnum_clobbers);

    case 299:
      return recog_297 (x1, insn, pnum_clobbers);

    case 351:
      return recog_311 (x1, insn, pnum_clobbers);

    case 380:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7196; /* aarch64_pred_negvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7207; /* aarch64_pred_negvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7218; /* aarch64_pred_negvnx2df */

        default:
          return -1;
        }

    case 383:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7197; /* aarch64_pred_frecpxvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7208; /* aarch64_pred_frecpxvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7219; /* aarch64_pred_frecpxvnx2df */

        default:
          return -1;
        }

    case 384:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7198; /* aarch64_pred_roundvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7209; /* aarch64_pred_roundvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7220; /* aarch64_pred_roundvnx2df */

        default:
          return -1;
        }

    case 385:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7199; /* aarch64_pred_nearbyintvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7210; /* aarch64_pred_nearbyintvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7221; /* aarch64_pred_nearbyintvnx2df */

        default:
          return -1;
        }

    case 386:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7200; /* aarch64_pred_floorvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7211; /* aarch64_pred_floorvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7222; /* aarch64_pred_floorvnx2df */

        default:
          return -1;
        }

    case 387:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7201; /* aarch64_pred_frintnvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7212; /* aarch64_pred_frintnvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7223; /* aarch64_pred_frintnvnx2df */

        default:
          return -1;
        }

    case 388:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7202; /* aarch64_pred_ceilvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7213; /* aarch64_pred_ceilvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7224; /* aarch64_pred_ceilvnx2df */

        default:
          return -1;
        }

    case 389:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7203; /* aarch64_pred_rintvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7214; /* aarch64_pred_rintvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7225; /* aarch64_pred_rintvnx2df */

        default:
          return -1;
        }

    case 390:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7204; /* aarch64_pred_btruncvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7215; /* aarch64_pred_btruncvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7226; /* aarch64_pred_btruncvnx2df */

        default:
          return -1;
        }

    case 392:
      switch (pattern167 (x1))
        {
        case 0:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7205; /* aarch64_pred_sqrtvnx8hf */

        case 1:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7216; /* aarch64_pred_sqrtvnx4sf */

        case 2:
          if (!
#line 3676 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7227; /* aarch64_pred_sqrtvnx2df */

        default:
          return -1;
        }

    case 323:
      switch (pattern169 (x1))
        {
        case 0:
          if (!(
#line 7684 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 9351; /* aarch64_fma_lane_vnx8bf */

        case 1:
          if (!
#line 7684 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9353; /* aarch64_fma_lane_vnx8hf */

        case 2:
          if (!
#line 7684 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9355; /* aarch64_fma_lane_vnx4sf */

        case 3:
          if (!
#line 7684 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9357; /* aarch64_fma_lane_vnx2df */

        default:
          return -1;
        }

    case 324:
      return recog_390 (x1, insn, pnum_clobbers);

    case 407:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9419; /* aarch64_fcmla_lane_vnx8hf */

        case 1:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9423; /* aarch64_fcmla_lane_vnx4sf */

        default:
          return -1;
        }

    case 408:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9420; /* aarch64_fcmla90_lane_vnx8hf */

        case 1:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9424; /* aarch64_fcmla90_lane_vnx4sf */

        default:
          return -1;
        }

    case 409:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9421; /* aarch64_fcmla180_lane_vnx8hf */

        case 1:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9425; /* aarch64_fcmla180_lane_vnx4sf */

        default:
          return -1;
        }

    case 410:
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9422; /* aarch64_fcmla270_lane_vnx8hf */

        case 1:
          if (!
#line 7914 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9426; /* aarch64_fcmla270_lane_vnx4sf */

        default:
          return -1;
        }

    case 327:
      return recog_355 (x1, insn, pnum_clobbers);

    case 579:
      if (pattern171 (x1) != 0
          || !
#line 3277 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9430; /* aarch64_sve_bfdotvnx4sf */

    case 580:
      if (pattern171 (x1) != 0
          || !
#line 3278 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9431; /* aarch64_sve_bfmlalbvnx4sf */

    case 581:
      if (pattern171 (x1) != 0
          || !
#line 3279 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9432; /* aarch64_sve_bfmlaltvnx4sf */

    case 582:
      if (pattern171 (x1) != 0
          || !
#line 3280 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9433; /* aarch64_sve_bfmlslbvnx4sf */

    case 583:
      if (pattern171 (x1) != 0
          || !
#line 3281 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9434; /* aarch64_sve_bfmlsltvnx4sf */

    case 584:
      if (pattern171 (x1) != 0
          || !
#line 3282 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16 && TARGET_NON_STREAMING))
        return -1;
      return 9435; /* aarch64_sve_bfmmlavnx4sf */

    case 326:
      return recog_389 (x1, insn, pnum_clobbers);

    case 126:
      return recog_298 (x1, insn, pnum_clobbers);

    case 140:
      return recog_324 (x1, insn, pnum_clobbers);

    case 141:
      return recog_323 (x1, insn, pnum_clobbers);

    case 142:
      return recog_322 (x1, insn, pnum_clobbers);

    case 143:
      return recog_321 (x1, insn, pnum_clobbers);

    case 136:
      return recog_320 (x1, insn, pnum_clobbers);

    case 137:
      return recog_319 (x1, insn, pnum_clobbers);

    case 138:
      return recog_318 (x1, insn, pnum_clobbers);

    case 139:
      return recog_317 (x1, insn, pnum_clobbers);

    case 144:
      return recog_316 (x1, insn, pnum_clobbers);

    case 145:
      return recog_315 (x1, insn, pnum_clobbers);

    case 149:
      return recog_308 (x1, insn, pnum_clobbers);

    case 150:
      return recog_307 (x1, insn, pnum_clobbers);

    case 151:
      return recog_364 (x1, insn, pnum_clobbers);

    case 173:
      return recog_335 (x1, insn, pnum_clobbers);

    case 340:
      return recog_341 (x1, insn, pnum_clobbers);

    case 369:
      return recog_345 (x1, insn, pnum_clobbers);

    case 370:
      return recog_344 (x1, insn, pnum_clobbers);

    case 394:
      return recog_343 (x1, insn, pnum_clobbers);

    case 397:
      return recog_342 (x1, insn, pnum_clobbers);

    case 368:
      return recog_310 (x1, insn, pnum_clobbers);

    case 300:
      if (pattern183 (x1) != 0
          || !
#line 10064 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10990; /* aarch64_brka */

    case 301:
      if (pattern183 (x1) != 0
          || !
#line 10064 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10991; /* aarch64_brkb */

    case 302:
      if (pattern164 (x1, 
E_VNx16BImode) != 0
          || !
#line 10144 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10996; /* aarch64_brkn */

    case 303:
      if (pattern164 (x1, 
E_VNx16BImode) != 0
          || !
#line 10144 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10997; /* aarch64_brkpa */

    case 304:
      if (pattern164 (x1, 
E_VNx16BImode) != 0
          || !
#line 10144 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10998; /* aarch64_brkpb */

    case 305:
      return recog_388 (x1, insn, pnum_clobbers);

    case 306:
      return recog_387 (x1, insn, pnum_clobbers);

    case 331:
      return recog_334 (x1, insn, pnum_clobbers);

    case 614:
      return recog_346 (x1, insn, pnum_clobbers);

    case 471:
      return recog_333 (x1, insn, pnum_clobbers);

    case 472:
      return recog_332 (x1, insn, pnum_clobbers);

    case 621:
      return recog_327 (x1, insn, pnum_clobbers);

    case 623:
      return recog_303 (x1, insn, pnum_clobbers);

    case 541:
      return recog_331 (x1, insn, pnum_clobbers);

    case 542:
      return recog_330 (x1, insn, pnum_clobbers);

    case 475:
      return recog_386 (x1, insn, pnum_clobbers);

    case 476:
      return recog_385 (x1, insn, pnum_clobbers);

    case 437:
      return recog_384 (x1, insn, pnum_clobbers);

    case 416:
      return recog_383 (x1, insn, pnum_clobbers);

    case 417:
      return recog_382 (x1, insn, pnum_clobbers);

    case 445:
      return recog_381 (x1, insn, pnum_clobbers);

    case 446:
      return recog_380 (x1, insn, pnum_clobbers);

    case 496:
      return recog_379 (x1, insn, pnum_clobbers);

    case 497:
      return recog_378 (x1, insn, pnum_clobbers);

    case 500:
      return recog_348 (x1, insn, pnum_clobbers);

    case 532:
      return recog_347 (x1, insn, pnum_clobbers);

    case 458:
      switch (pattern192 (x1))
        {
        case 0:
          if (!
#line 2548 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12357; /* aarch64_sve_fmlalbvnx4sf */

        case 1:
          if (!
#line 2565 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12361; /* aarch64_fmlalb_lane_vnx4sf */

        default:
          return -1;
        }

    case 464:
      switch (pattern192 (x1))
        {
        case 0:
          if (!
#line 2548 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12358; /* aarch64_sve_fmlaltvnx4sf */

        case 1:
          if (!
#line 2565 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12362; /* aarch64_fmlalt_lane_vnx4sf */

        default:
          return -1;
        }

    case 466:
      switch (pattern192 (x1))
        {
        case 0:
          if (!
#line 2548 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12359; /* aarch64_sve_fmlslbvnx4sf */

        case 1:
          if (!
#line 2565 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12363; /* aarch64_fmlslb_lane_vnx4sf */

        default:
          return -1;
        }

    case 467:
      switch (pattern192 (x1))
        {
        case 0:
          if (!
#line 2548 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12360; /* aarch64_sve_fmlsltvnx4sf */

        case 1:
          if (!
#line 2565 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12364; /* aarch64_fmlslt_lane_vnx4sf */

        default:
          return -1;
        }

    case 419:
      switch (pattern194 (x1))
        {
        case 0:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12415; /* aarch64_sve_addhntvnx8hi */

        case 1:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12419; /* aarch64_sve_addhntvnx4si */

        case 2:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12423; /* aarch64_sve_addhntvnx2di */

        default:
          return -1;
        }

    case 484:
      switch (pattern194 (x1))
        {
        case 0:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12416; /* aarch64_sve_raddhntvnx8hi */

        case 1:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12420; /* aarch64_sve_raddhntvnx4si */

        case 2:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12424; /* aarch64_sve_raddhntvnx2di */

        default:
          return -1;
        }

    case 488:
      switch (pattern194 (x1))
        {
        case 0:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12417; /* aarch64_sve_rsubhntvnx8hi */

        case 1:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12421; /* aarch64_sve_rsubhntvnx4si */

        case 2:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12425; /* aarch64_sve_rsubhntvnx2di */

        default:
          return -1;
        }

    case 544:
      switch (pattern194 (x1))
        {
        case 0:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12418; /* aarch64_sve_subhntvnx8hi */

        case 1:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12422; /* aarch64_sve_subhntvnx4si */

        case 2:
          if (!
#line 2711 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12426; /* aarch64_sve_subhntvnx2di */

        default:
          return -1;
        }

    case 486:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12454; /* aarch64_sve_rshrntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12462; /* aarch64_sve_rshrntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12470; /* aarch64_sve_rshrntvnx2di */

        default:
          return -1;
        }

    case 499:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12455; /* aarch64_sve_shrntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12463; /* aarch64_sve_shrntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12471; /* aarch64_sve_shrntvnx2di */

        default:
          return -1;
        }

    case 519:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12456; /* aarch64_sve_sqrshrntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12464; /* aarch64_sve_sqrshrntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12472; /* aarch64_sve_sqrshrntvnx2di */

        default:
          return -1;
        }

    case 523:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12457; /* aarch64_sve_sqrshruntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12465; /* aarch64_sve_sqrshruntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12473; /* aarch64_sve_sqrshruntvnx2di */

        default:
          return -1;
        }

    case 525:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12458; /* aarch64_sve_sqshrntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12466; /* aarch64_sve_sqshrntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12474; /* aarch64_sve_sqshrntvnx2di */

        default:
          return -1;
        }

    case 527:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12459; /* aarch64_sve_sqshruntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12467; /* aarch64_sve_sqshruntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12475; /* aarch64_sve_sqshruntvnx2di */

        default:
          return -1;
        }

    case 562:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12460; /* aarch64_sve_uqrshrntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12468; /* aarch64_sve_uqrshrntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12476; /* aarch64_sve_uqrshrntvnx2di */

        default:
          return -1;
        }

    case 564:
      switch (pattern195 (x1))
        {
        case 0:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12461; /* aarch64_sve_uqshrntvnx8hi */

        case 1:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12469; /* aarch64_sve_uqshrntvnx4si */

        case 2:
          if (!
#line 2773 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12477; /* aarch64_sve_uqshrntvnx2di */

        default:
          return -1;
        }

    case 241:
      return recog_377 (x1, insn, pnum_clobbers);

    case 501:
      return recog_376 (x1, insn, pnum_clobbers);

    case 502:
      return recog_375 (x1, insn, pnum_clobbers);

    case 553:
      return recog_374 (x1, insn, pnum_clobbers);

    case 554:
      return recog_373 (x1, insn, pnum_clobbers);

    case 451:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12516; /* aarch64_pred_faddpvnx8hf */

        case 1:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12521; /* aarch64_pred_faddpvnx4sf */

        case 2:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12526; /* aarch64_pred_faddpvnx2df */

        default:
          return -1;
        }

    case 455:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12517; /* aarch64_pred_fmaxpvnx8hf */

        case 1:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12522; /* aarch64_pred_fmaxpvnx4sf */

        case 2:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12527; /* aarch64_pred_fmaxpvnx2df */

        default:
          return -1;
        }

    case 454:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12518; /* aarch64_pred_fmaxnmpvnx8hf */

        case 1:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12523; /* aarch64_pred_fmaxnmpvnx4sf */

        case 2:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12528; /* aarch64_pred_fmaxnmpvnx2df */

        default:
          return -1;
        }

    case 457:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12519; /* aarch64_pred_fminpvnx8hf */

        case 1:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12524; /* aarch64_pred_fminpvnx4sf */

        case 2:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12529; /* aarch64_pred_fminpvnx2df */

        default:
          return -1;
        }

    case 456:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12520; /* aarch64_pred_fminnmpvnx8hf */

        case 1:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12525; /* aarch64_pred_fminnmpvnx4sf */

        case 2:
          if (!
#line 2846 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12530; /* aarch64_pred_fminnmpvnx2df */

        default:
          return -1;
        }

    case 429:
      return recog_363 (x1, insn, pnum_clobbers);

    case 432:
      return recog_362 (x1, insn, pnum_clobbers);

    case 430:
      return recog_361 (x1, insn, pnum_clobbers);

    case 431:
      return recog_360 (x1, insn, pnum_clobbers);

    case 512:
      return recog_359 (x1, insn, pnum_clobbers);

    case 515:
      return recog_358 (x1, insn, pnum_clobbers);

    case 513:
      return recog_357 (x1, insn, pnum_clobbers);

    case 514:
      return recog_356 (x1, insn, pnum_clobbers);

    case 425:
      return recog_372 (x1, insn, pnum_clobbers);

    case 428:
      return recog_371 (x1, insn, pnum_clobbers);

    case 426:
      return recog_370 (x1, insn, pnum_clobbers);

    case 427:
      return recog_369 (x1, insn, pnum_clobbers);

    case 438:
      return recog_367 (x1, insn, pnum_clobbers);

    case 440:
      return recog_366 (x1, insn, pnum_clobbers);

    case 453:
      return recog_354 (x1, insn, pnum_clobbers);

    case 442:
      return recog_353 (x1, insn, pnum_clobbers);

    case 598:
      return recog_326 (x1, insn, pnum_clobbers);

    case 245:
      return recog_329 (x1, insn, pnum_clobbers);

    case 469:
      return recog_368 (x1, insn, pnum_clobbers);

    case 649:
      return recog_339 (x1, insn, pnum_clobbers);

    case 702:
      if (pattern46 (x1, 
E_DImode, 
E_VNx16QImode, 
93) != 0
          || !
#line 1046 "../../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_SME))
        return -1;
      return 13405; /* aarch64_sme_zero_za */

    default:
      return -1;
    }
}

 int
recog_464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern619 (x2, 
E_SImode))
                {
                case 0:
                  return 215; /* *add_extendqi_si */

                case 1:
                  return 219; /* *add_extendhi_si */

                case 2:
                  return 223; /* *add_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern619 (x2, 
E_DImode))
                {
                case 0:
                  return 217; /* *add_extendqi_di */

                case 1:
                  return 221; /* *add_extendhi_di */

                case 2:
                  return 225; /* *add_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern620 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3064; /* aarch64_saddwv8qi */

            case E_V4SImode:
              if (pattern620 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3066; /* aarch64_saddwv4hi */

            case E_V2DImode:
              if (pattern620 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4703 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3068; /* aarch64_saddwv2si */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern296 (x2))
            {
            case 0:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3034; /* aarch64_saddlv8qi */

            case 1:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3038; /* aarch64_saddlv4hi */

            case 2:
              if (!
#line 4601 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3042; /* aarch64_saddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern621 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3010; /* aarch64_saddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3022; /* aarch64_saddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3014; /* aarch64_saddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3026; /* aarch64_saddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4481 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3018; /* aarch64_saddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4494 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3030; /* aarch64_saddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern623 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3070; /* aarch64_saddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3076; /* aarch64_saddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3072; /* aarch64_saddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3078; /* aarch64_saddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4716 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3074; /* aarch64_saddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4729 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3080; /* aarch64_saddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_469 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x3, 1);
  if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
    {
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (cc_register (operands[2], E_VOIDmode))
        {
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (register_operand (operands[0], E_QImode)
                  && GET_MODE (x2) == E_QImode
                  && aarch64_comparison_operator_mode (operands[1], E_QImode))
                return 450; /* cstoreqi_neg */
              break;

            case E_HImode:
              if (register_operand (operands[0], E_HImode)
                  && GET_MODE (x2) == E_HImode
                  && aarch64_comparison_operator_mode (operands[1], E_HImode))
                return 451; /* cstorehi_neg */
              break;

            case E_SImode:
              if (register_operand (operands[0], E_SImode)
                  && GET_MODE (x2) == E_SImode
                  && aarch64_comparison_operator_mode (operands[1], E_SImode))
                return 452; /* cstoresi_neg */
              break;

            case E_DImode:
              if (register_operand (operands[0], E_DImode)
                  && GET_MODE (x2) == E_DImode
                  && aarch64_comparison_operator_mode (operands[1], E_DImode))
                return 453; /* cstoredi_neg */
              break;

            default:
              break;
            }
        }
    }
  switch (GET_CODE (x3))
    {
    case LT:
      switch (pattern402 (x2))
        {
        case 0:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4076; /* aarch64_cmltv8qi */

        case 1:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4091; /* aarch64_cmltv16qi */

        case 2:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4096; /* aarch64_cmltv4hi */

        case 3:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4241; /* aarch64_cmltv4hf */

        case 4:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4111; /* aarch64_cmltv8hi */

        case 5:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4256; /* aarch64_cmltv8hf */

        case 6:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4116; /* aarch64_cmltv2si */

        case 7:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4261; /* aarch64_cmltv2sf */

        case 8:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4131; /* aarch64_cmltv4si */

        case 9:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4276; /* aarch64_cmltv4sf */

        case 10:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4136; /* aarch64_cmltv2di */

        case 11:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4281; /* aarch64_cmltv2df */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4141; /* aarch64_cmltdi */
            }
          if (!
#line 7245 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4146; /* *aarch64_cmltdi */

        case 13:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4296; /* aarch64_cmltdf */

        case 14:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4286; /* aarch64_cmlthf */

        case 15:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4291; /* aarch64_cmltsf */

        case 16:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4311; /* aarch64_facltv4hf */

        case 17:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4323; /* aarch64_facltv8hf */

        case 18:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4327; /* aarch64_facltv2sf */

        case 19:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4339; /* aarch64_facltv4sf */

        case 20:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4343; /* aarch64_facltv2df */

        case 21:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4347; /* aarch64_faclthf */

        case 22:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4351; /* aarch64_facltsf */

        case 23:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4355; /* aarch64_facltdf */

        default:
          return -1;
        }

    case LE:
      switch (pattern402 (x2))
        {
        case 0:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4079; /* aarch64_cmlev8qi */

        case 1:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4092; /* aarch64_cmlev16qi */

        case 2:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4099; /* aarch64_cmlev4hi */

        case 3:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4244; /* aarch64_cmlev4hf */

        case 4:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4112; /* aarch64_cmlev8hi */

        case 5:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4257; /* aarch64_cmlev8hf */

        case 6:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4119; /* aarch64_cmlev2si */

        case 7:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4264; /* aarch64_cmlev2sf */

        case 8:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4132; /* aarch64_cmlev4si */

        case 9:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4277; /* aarch64_cmlev4sf */

        case 10:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4137; /* aarch64_cmlev2di */

        case 11:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4282; /* aarch64_cmlev2df */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4142; /* aarch64_cmledi */
            }
          if (!
#line 7245 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4147; /* *aarch64_cmledi */

        case 13:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4299; /* aarch64_cmledf */

        case 14:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4287; /* aarch64_cmlehf */

        case 15:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4292; /* aarch64_cmlesf */

        case 16:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4314; /* aarch64_faclev4hf */

        case 17:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4324; /* aarch64_faclev8hf */

        case 18:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4330; /* aarch64_faclev2sf */

        case 19:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4340; /* aarch64_faclev4sf */

        case 20:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4344; /* aarch64_faclev2df */

        case 21:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4348; /* aarch64_faclehf */

        case 22:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4352; /* aarch64_faclesf */

        case 23:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4358; /* aarch64_facledf */

        default:
          return -1;
        }

    case EQ:
      switch (pattern400 (x2))
        {
        case 0:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4082; /* aarch64_cmeqv8qi */

        case 1:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4093; /* aarch64_cmeqv16qi */

        case 2:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4102; /* aarch64_cmeqv4hi */

        case 3:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4247; /* aarch64_cmeqv4hf */

        case 4:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4113; /* aarch64_cmeqv8hi */

        case 5:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4258; /* aarch64_cmeqv8hf */

        case 6:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4122; /* aarch64_cmeqv2si */

        case 7:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4267; /* aarch64_cmeqv2sf */

        case 8:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4133; /* aarch64_cmeqv4si */

        case 9:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4278; /* aarch64_cmeqv4sf */

        case 10:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4138; /* aarch64_cmeqv2di */

        case 11:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4283; /* aarch64_cmeqv2df */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4143; /* aarch64_cmeqdi */
            }
          if (!
#line 7245 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4148; /* *aarch64_cmeqdi */

        case 13:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4302; /* aarch64_cmeqdf */

        case 14:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4288; /* aarch64_cmeqhf */

        case 15:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4293; /* aarch64_cmeqsf */

        default:
          return -1;
        }

    case GE:
      switch (pattern402 (x2))
        {
        case 0:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4085; /* aarch64_cmgev8qi */

        case 1:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4094; /* aarch64_cmgev16qi */

        case 2:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4105; /* aarch64_cmgev4hi */

        case 3:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4250; /* aarch64_cmgev4hf */

        case 4:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4114; /* aarch64_cmgev8hi */

        case 5:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4259; /* aarch64_cmgev8hf */

        case 6:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4125; /* aarch64_cmgev2si */

        case 7:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4270; /* aarch64_cmgev2sf */

        case 8:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4134; /* aarch64_cmgev4si */

        case 9:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4279; /* aarch64_cmgev4sf */

        case 10:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4139; /* aarch64_cmgev2di */

        case 11:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4284; /* aarch64_cmgev2df */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4144; /* aarch64_cmgedi */
            }
          if (!
#line 7245 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4149; /* *aarch64_cmgedi */

        case 13:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4305; /* aarch64_cmgedf */

        case 14:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4289; /* aarch64_cmgehf */

        case 15:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4294; /* aarch64_cmgesf */

        case 16:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4317; /* aarch64_facgev4hf */

        case 17:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4325; /* aarch64_facgev8hf */

        case 18:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4333; /* aarch64_facgev2sf */

        case 19:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4341; /* aarch64_facgev4sf */

        case 20:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4345; /* aarch64_facgev2df */

        case 21:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4349; /* aarch64_facgehf */

        case 22:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4353; /* aarch64_facgesf */

        case 23:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4361; /* aarch64_facgedf */

        default:
          return -1;
        }

    case GT:
      switch (pattern402 (x2))
        {
        case 0:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4088; /* aarch64_cmgtv8qi */

        case 1:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4095; /* aarch64_cmgtv16qi */

        case 2:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4108; /* aarch64_cmgtv4hi */

        case 3:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4253; /* aarch64_cmgtv4hf */

        case 4:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4115; /* aarch64_cmgtv8hi */

        case 5:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4260; /* aarch64_cmgtv8hf */

        case 6:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4128; /* aarch64_cmgtv2si */

        case 7:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4273; /* aarch64_cmgtv2sf */

        case 8:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4135; /* aarch64_cmgtv4si */

        case 9:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4280; /* aarch64_cmgtv4sf */

        case 10:
          if (!
#line 7196 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4140; /* aarch64_cmgtv2di */

        case 11:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4285; /* aarch64_cmgtv2df */

        case 12:
          if (pnum_clobbers != NULL
              && 
#line 7211 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4145; /* aarch64_cmgtdi */
            }
          if (!
#line 7245 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4150; /* *aarch64_cmgtdi */

        case 13:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4308; /* aarch64_cmgtdf */

        case 14:
          if (!(
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4290; /* aarch64_cmgthf */

        case 15:
          if (!
#line 7413 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4295; /* aarch64_cmgtsf */

        case 16:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4320; /* aarch64_facgtv4hf */

        case 17:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4326; /* aarch64_facgtv8hf */

        case 18:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4336; /* aarch64_facgtv2sf */

        case 19:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4342; /* aarch64_facgtv4sf */

        case 20:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4346; /* aarch64_facgtv2df */

        case 21:
          if (!(
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 4350; /* aarch64_facgthf */

        case 22:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4354; /* aarch64_facgtsf */

        case 23:
          if (!
#line 7434 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4364; /* aarch64_facgtdf */

        default:
          return -1;
        }

    case LTU:
      switch (pattern403 (x2))
        {
        case 0:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4151; /* aarch64_cmltuv8qi */

        case 1:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4163; /* aarch64_cmltuv16qi */

        case 2:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4167; /* aarch64_cmltuv4hi */

        case 3:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4179; /* aarch64_cmltuv8hi */

        case 4:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4183; /* aarch64_cmltuv2si */

        case 5:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4195; /* aarch64_cmltuv4si */

        case 6:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4199; /* aarch64_cmltuv2di */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4203; /* aarch64_cmltudi */
            }
          if (!
#line 7308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4207; /* *aarch64_cmltudi */

        default:
          return -1;
        }

    case LEU:
      switch (pattern403 (x2))
        {
        case 0:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4154; /* aarch64_cmleuv8qi */

        case 1:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4164; /* aarch64_cmleuv16qi */

        case 2:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4170; /* aarch64_cmleuv4hi */

        case 3:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4180; /* aarch64_cmleuv8hi */

        case 4:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4186; /* aarch64_cmleuv2si */

        case 5:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4196; /* aarch64_cmleuv4si */

        case 6:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4200; /* aarch64_cmleuv2di */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4204; /* aarch64_cmleudi */
            }
          if (!
#line 7308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4208; /* *aarch64_cmleudi */

        default:
          return -1;
        }

    case GEU:
      switch (pattern403 (x2))
        {
        case 0:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4157; /* aarch64_cmgeuv8qi */

        case 1:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4165; /* aarch64_cmgeuv16qi */

        case 2:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4173; /* aarch64_cmgeuv4hi */

        case 3:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4181; /* aarch64_cmgeuv8hi */

        case 4:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4189; /* aarch64_cmgeuv2si */

        case 5:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4197; /* aarch64_cmgeuv4si */

        case 6:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4201; /* aarch64_cmgeuv2di */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4205; /* aarch64_cmgeudi */
            }
          if (!
#line 7308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4209; /* *aarch64_cmgeudi */

        default:
          return -1;
        }

    case GTU:
      switch (pattern403 (x2))
        {
        case 0:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4160; /* aarch64_cmgtuv8qi */

        case 1:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4166; /* aarch64_cmgtuv16qi */

        case 2:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4176; /* aarch64_cmgtuv4hi */

        case 3:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4182; /* aarch64_cmgtuv8hi */

        case 4:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4192; /* aarch64_cmgtuv2si */

        case 5:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4198; /* aarch64_cmgtuv4si */

        case 6:
          if (!
#line 7261 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 4202; /* aarch64_cmgtuv2di */

        case 7:
          if (pnum_clobbers != NULL
              && 
#line 7274 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            {
              *pnum_clobbers = 1;
              return 4206; /* aarch64_cmgtudi */
            }
          if (!
#line 7308 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && reload_completed))
            return -1;
          return 4210; /* *aarch64_cmgtudi */

        default:
          return -1;
        }

    case NE:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) != AND
          || GET_MODE (x5) != E_DImode
          || x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      if (pnum_clobbers != NULL
          && 
#line 7362 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        {
          *pnum_clobbers = 1;
          return 4237; /* aarch64_cmtstdi */
        }
      if (!
#line 7399 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4238; /* *aarch64_cmtstdi */

    default:
      return -1;
    }
}

 int
recog_490 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[4] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HFmode:
          if (pattern968 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2855 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2417; /* fmav4hf4_vec_concatz_be */

        case E_V4SFmode:
          if (pattern968 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2855 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2421; /* fmav2sf4_vec_concatz_be */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          if (GET_MODE (x8) != E_SFmode)
            return -1;
          x9 = XEXP (x8, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1
              || pattern912 (x2) != 0)
            return -1;
          x10 = XEXP (x8, 0);
          operands[1] = x10;
          x11 = XVECEXP (x9, 0, 0);
          operands[2] = x11;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V2SFmode))
            return -1;
          x7 = XEXP (x3, 2);
          operands[4] = x7;
          if (!register_operand (operands[4], E_V2SFmode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_V2SFmode:
              if (!register_operand (operands[1], E_V2SFmode)
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2869 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2426; /* *aarch64_fma4_eltv2sf_vec_concatz_be */

            case E_V4SFmode:
              if (!register_operand (operands[1], E_V4SFmode)
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2886 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2431; /* *aarch64_fma4_elt_to_128v2sf_vec_concatz_be */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x7 = XEXP (x3, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (pattern1023 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2901 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2435; /* *aarch64_fma4_elt_from_dupv4hi_vec_concatz_be */

            case E_V4SImode:
              if (pattern1023 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2901 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2439; /* *aarch64_fma4_elt_from_dupv2si_vec_concatz_be */

            case E_V8HFmode:
              if (pattern1023 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2901 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2443; /* *aarch64_fma4_elt_from_dupv4hf_vec_concatz_be */

            case E_V4SFmode:
              if (pattern1023 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2901 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2447; /* *aarch64_fma4_elt_from_dupv2sf_vec_concatz_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x5 = XEXP (x2, 0);
          operands[4] = x5;
          x8 = XEXP (x4, 0);
          operands[1] = x8;
          x7 = XEXP (x3, 2);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_V8HFmode:
              if (pattern1024 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2928 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2453; /* fnmav4hf4_vec_concatz_be */

            case E_V4SFmode:
              if (pattern1024 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
                  || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2928 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2457; /* fnmav2sf4_vec_concatz_be */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x12 = XEXP (x6, 0);
          switch (GET_CODE (x12))
            {
            case VEC_SELECT:
              if (GET_MODE (x12) != E_SFmode)
                return -1;
              x13 = XEXP (x12, 1);
              if (GET_CODE (x13) != PARALLEL
                  || XVECLEN (x13, 0) != 1
                  || pattern912 (x2) != 0)
                return -1;
              x8 = XEXP (x4, 0);
              operands[3] = x8;
              if (!register_operand (operands[3], E_V2SFmode)
                  || GET_MODE (x6) != E_V2SFmode)
                return -1;
              x14 = XEXP (x12, 0);
              operands[1] = x14;
              x15 = XVECEXP (x13, 0, 0);
              operands[2] = x15;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x7 = XEXP (x3, 2);
              operands[4] = x7;
              if (!register_operand (operands[4], E_V2SFmode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2943 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2462; /* *aarch64_fnma4_eltv2sf_vec_concatz_be */

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2961 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2467; /* *aarch64_fnma4_elt_to_128v2sf_vec_concatz_be */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x12;
              x5 = XEXP (x2, 0);
              operands[4] = x5;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x7 = XEXP (x3, 2);
              operands[3] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_V8HImode:
                  if (pattern1086 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                      || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2977 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2471; /* *aarch64_fnma4_elt_from_dupv4hi_vec_concatz_be */

                case E_V4SImode:
                  if (pattern1086 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                      || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2977 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2475; /* *aarch64_fnma4_elt_from_dupv2si_vec_concatz_be */

                case E_V8HFmode:
                  if (pattern1086 (x2, 
E_V4HFmode, 
E_HFmode, 
E_V8HFmode) != 0
                      || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2977 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                    return -1;
                  return 2479; /* *aarch64_fnma4_elt_from_dupv4hf_vec_concatz_be */

                case E_V4SFmode:
                  if (pattern1086 (x2, 
E_V2SFmode, 
E_SFmode, 
E_V4SFmode) != 0
                      || !(
#line 37 "../../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2977 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2483; /* *aarch64_fnma4_elt_from_dupv2sf_vec_concatz_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_493 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 405:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 439 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 1401; /* aarch64_fcadd90v4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 439 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
            return -1;
          return 1409; /* aarch64_fcadd90v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 406:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 439 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 1404; /* aarch64_fcadd270v4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 439 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX)))
            return -1;
          return 1412; /* aarch64_fcadd270v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 186:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1957; /* aarch64_simd_reg_shlv8qi_unsigned_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1961; /* aarch64_simd_reg_shlv4hi_unsigned_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1414 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1965; /* aarch64_simd_reg_shlv2si_unsigned_vec_concatz_le */

        default:
          return -1;
        }

    case 185:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1424 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1970; /* aarch64_simd_reg_shlv8qi_signed_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1424 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1974; /* aarch64_simd_reg_shlv4hi_signed_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1424 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1978; /* aarch64_simd_reg_shlv2si_signed_vec_concatz_le */

        default:
          return -1;
        }

    case 274:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern972 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1983; /* vec_shr_v8qi_vec_concatz_le */

        case E_V8HImode:
          if (pattern972 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1986; /* vec_shr_v4hi_vec_concatz_le */

        case E_V8HFmode:
          if (pattern972 (x2, 
E_V4HFmode, 
E_V8HFmode) != 0
              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1989; /* vec_shr_v4hf_vec_concatz_le */

        case E_V4SImode:
          if (pattern972 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1992; /* vec_shr_v2si_vec_concatz_le */

        case E_V4SFmode:
          if (pattern972 (x2, 
E_V2SFmode, 
E_V4SFmode) != 0
              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1995; /* vec_shr_v2sf_vec_concatz_le */

        case E_V8BFmode:
          if (pattern972 (x2, 
E_V4BFmode, 
E_V8BFmode) != 0
              || !(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1606 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1998; /* vec_shr_v4bf_vec_concatz_le */

        default:
          return -1;
        }

    case 208:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2121; /* aarch64_umaxpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2137; /* aarch64_umaxpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2153; /* aarch64_umaxpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 209:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2124; /* aarch64_uminpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2140; /* aarch64_uminpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2156; /* aarch64_uminpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 206:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2127; /* aarch64_smaxpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2143; /* aarch64_smaxpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2159; /* aarch64_smaxpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 207:
      switch (pattern671 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2130; /* aarch64_sminpv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2146; /* aarch64_sminpv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1800 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2162; /* aarch64_sminpv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 198:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2169; /* aarch64_smax_nanpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2185; /* aarch64_smax_nanpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 201:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2172; /* aarch64_smin_nanpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2188; /* aarch64_smin_nanpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 197:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2175; /* aarch64_smaxpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2191; /* aarch64_smaxpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 200:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2178; /* aarch64_sminpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1811 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2194; /* aarch64_sminpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 196:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2681; /* fmax_nanv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2697; /* fmax_nanv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 199:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2684; /* fmin_nanv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2700; /* fmin_nanv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 277:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2687; /* fmaxv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2703; /* fmaxv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 278:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2690; /* fminv4hf3_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3361 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2706; /* fminv2sf3_vec_concatz_le */

        default:
          return -1;
        }

    case 202:
      switch (pattern670 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2717; /* aarch64_faddpv4hf_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3373 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2721; /* aarch64_faddpv2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 221:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3311; /* aarch64_suqaddv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3319; /* aarch64_suqaddv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3327; /* aarch64_suqaddv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3343; /* aarch64_suqadddi_vec_concatz_le */

        default:
          return -1;
        }

    case 220:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3314; /* aarch64_usqaddv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3322; /* aarch64_usqaddv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3330; /* aarch64_usqaddv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5380 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3346; /* aarch64_usqadddi_vec_concatz_le */

        default:
          return -1;
        }

    case 216:
      switch (pattern674 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3441; /* aarch64_sqdmulhv4hi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3449; /* aarch64_sqdmulhv2si_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3461; /* aarch64_sqdmulh_nv4hi_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3469; /* aarch64_sqdmulh_nv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3477; /* aarch64_sqdmulh_lanev4hi_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3493; /* aarch64_sqdmulh_laneqv4hi_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3485; /* aarch64_sqdmulh_lanev2si_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3501; /* aarch64_sqdmulh_laneqv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 217:
      switch (pattern674 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3444; /* aarch64_sqrdmulhv4hi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5555 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3452; /* aarch64_sqrdmulhv2si_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3464; /* aarch64_sqrdmulh_nv4hi_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5567 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3472; /* aarch64_sqrdmulh_nv2si_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3480; /* aarch64_sqrdmulh_lanev4hi_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3496; /* aarch64_sqrdmulh_laneqv4hi_vec_concatz_le */

        case 6:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5582 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3488; /* aarch64_sqrdmulh_lanev2si_vec_concatz_le */

        case 7:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5597 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3504; /* aarch64_sqrdmulh_laneqv2si_vec_concatz_le */

        default:
          return -1;
        }

    case 229:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3643; /* aarch64_sshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3659; /* aarch64_sshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3675; /* aarch64_sshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3695; /* aarch64_sshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 230:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3646; /* aarch64_ushlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3662; /* aarch64_ushlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3678; /* aarch64_ushlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3698; /* aarch64_ushldi_vec_concatz_le */

        default:
          return -1;
        }

    case 231:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3649; /* aarch64_srshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3665; /* aarch64_srshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3681; /* aarch64_srshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3701; /* aarch64_srshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 232:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3652; /* aarch64_urshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3668; /* aarch64_urshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3684; /* aarch64_urshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6507 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3704; /* aarch64_urshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 227:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3707; /* aarch64_sqshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3723; /* aarch64_sqshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3739; /* aarch64_sqshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3771; /* aarch64_sqshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 228:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3710; /* aarch64_uqshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3726; /* aarch64_uqshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3742; /* aarch64_uqshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3774; /* aarch64_uqshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 233:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3713; /* aarch64_sqrshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3729; /* aarch64_sqrshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3745; /* aarch64_sqrshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3777; /* aarch64_sqrshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 234:
      switch (pattern672 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3716; /* aarch64_uqrshlv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3732; /* aarch64_uqrshlv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3748; /* aarch64_uqrshlv2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6521 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 3780; /* aarch64_uqrshldi_vec_concatz_le */

        default:
          return -1;
        }

    case 247:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4845; /* aarch64_zip1v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4869; /* aarch64_zip1v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4893; /* aarch64_zip1v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4923; /* aarch64_zip1v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4947; /* aarch64_zip1v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4971; /* aarch64_zip1v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 248:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4848; /* aarch64_zip2v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4872; /* aarch64_zip2v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4896; /* aarch64_zip2v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4926; /* aarch64_zip2v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4950; /* aarch64_zip2v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4974; /* aarch64_zip2v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 251:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4851; /* aarch64_trn1v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4875; /* aarch64_trn1v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4899; /* aarch64_trn1v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4929; /* aarch64_trn1v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4953; /* aarch64_trn1v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4977; /* aarch64_trn1v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 252:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4854; /* aarch64_trn2v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4878; /* aarch64_trn2v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4902; /* aarch64_trn2v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4932; /* aarch64_trn2v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4956; /* aarch64_trn2v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4980; /* aarch64_trn2v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 249:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4857; /* aarch64_uzp1v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4881; /* aarch64_uzp1v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4905; /* aarch64_uzp1v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4935; /* aarch64_uzp1v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4959; /* aarch64_uzp1v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4983; /* aarch64_uzp1v2sf_vec_concatz_le */

        default:
          return -1;
        }

    case 250:
      switch (pattern675 (x2))
        {
        case 0:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4860; /* aarch64_uzp2v8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4884; /* aarch64_uzp2v4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4908; /* aarch64_uzp2v2si_vec_concatz_le */

        case 3:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4938; /* aarch64_uzp2v4hf_vec_concatz_le */

        case 4:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4962; /* aarch64_uzp2v4bf_vec_concatz_le */

        case 5:
          if (!(
#line 28 "../../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8634 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4986; /* aarch64_uzp2v2sf_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          return recog_8 (x1, insn, pnum_clobbers);

        case ASHIFT:
          x6 = XEXP (x5, 1);
          if (GET_CODE (x6) != CONST_INT)
            return -1;
          operands[2] = x6;
          res = recog_7 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (XWINT (x6, 0) != 8L)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != AND)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != LSHIFTRT)
            return -1;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x4, 1);
          operands[3] = x11;
          x12 = XEXP (x7, 1);
          operands[2] = x12;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1168 (x3, 
E_SImode) != 0
                  || !
#line 6778 "../../../gcc/config/aarch64/aarch64.md"
(aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)))
                return -1;
              return 890; /* aarch64_rev16si2_alt1 */

            case E_DImode:
              if (pattern1168 (x3, 
E_DImode) != 0
                  || !
#line 6778 "../../../gcc/config/aarch64/aarch64.md"
(aarch_rev16_shleft_mask_imm_p (operands[3], DImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], DImode)))
                return -1;
              return 891; /* aarch64_rev16di2_alt1 */

            default:
              return -1;
            }

        case LSHIFTRT:
          x6 = XEXP (x5, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != AND)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != ASHIFT)
            return -1;
          x9 = XEXP (x8, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          x11 = XEXP (x4, 1);
          operands[2] = x11;
          x12 = XEXP (x7, 1);
          operands[3] = x12;
          x13 = XEXP (x8, 0);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1117 (x3, 
E_SImode) != 0
                  || !
#line 6792 "../../../gcc/config/aarch64/aarch64.md"
(aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode)))
                return -1;
              return 892; /* *aarch64_rev16si2_alt2 */

            case E_DImode:
              if (pattern1117 (x3, 
E_DImode) != 0
                  || !
#line 6792 "../../../gcc/config/aarch64/aarch64.md"
(aarch_rev16_shleft_mask_imm_p (operands[3], DImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], DImode)))
                return -1;
              return 893; /* *aarch64_rev16di2_alt2 */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != CONST_INT
              || XWINT (x11, 0) != -1080863910568919041L)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_DImode)
            return -1;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 174
              || GET_MODE (x8) != E_QImode)
            return -1;
          x14 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x14) != AND
              || GET_MODE (x14) != E_QImode)
            return -1;
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != LSHIFTRT
              || GET_MODE (x15) != E_DImode)
            return -1;
          x16 = XEXP (x15, 1);
          if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 56])
            return -1;
          x17 = XEXP (x14, 1);
          if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
              || pattern793 (x3) != 0)
            return -1;
          x10 = XEXP (x5, 0);
          operands[1] = x10;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x6 = XEXP (x5, 1);
          operands[2] = x6;
          if (!aarch64_granule16_uimm6 (operands[2], E_DImode))
            return -1;
          x18 = XVECEXP (x8, 0, 1);
          operands[3] = x18;
          if (!aarch64_memtag_tag_offset (operands[3], E_QImode))
            return -1;
          x19 = XEXP (x15, 0);
          if (!rtx_equal_p (x19, operands[1])
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
            return -1;
          return 1228; /* addg */

        default:
          return -1;
        }

    case NEG:
      switch (pattern48 (x3))
        {
        case 0:
          return 460; /* *cmovsi_insn_m1 */

        case 1:
          return 461; /* *cmovdi_insn_m1 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern587 (x3, 
E_SImode) != 0)
            return -1;
          return 505; /* iorsi3 */

        case E_DImode:
          if (pattern587 (x3, 
E_DImode) != 0)
            return -1;
          return 508; /* iordi3 */

        case E_V8QImode:
          if (pattern588 (x3, 
E_V8QImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1776; /* iorv8qi3 */

        case E_V16QImode:
          if (pattern588 (x3, 
E_V16QImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1779; /* iorv16qi3 */

        case E_V4HImode:
          if (pattern588 (x3, 
E_V4HImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1780; /* iorv4hi3 */

        case E_V8HImode:
          if (pattern588 (x3, 
E_V8HImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1783; /* iorv8hi3 */

        case E_V2SImode:
          if (pattern588 (x3, 
E_V2SImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1784; /* iorv2si3 */

        case E_V4SImode:
          if (pattern588 (x3, 
E_V4SImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1787; /* iorv4si3 */

        case E_V2DImode:
          if (pattern588 (x3, 
E_V2DImode) != 0
              || !
#line 1138 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1788; /* iorv2di3 */

        case E_VNx16QImode:
          if (pattern589 (x3, 
E_VNx16QImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8171; /* iorvnx16qi3 */

        case E_VNx8QImode:
          if (pattern589 (x3, 
E_VNx8QImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8174; /* iorvnx8qi3 */

        case E_VNx4QImode:
          if (pattern589 (x3, 
E_VNx4QImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8177; /* iorvnx4qi3 */

        case E_VNx2QImode:
          if (pattern589 (x3, 
E_VNx2QImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8180; /* iorvnx2qi3 */

        case E_VNx8HImode:
          if (pattern589 (x3, 
E_VNx8HImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8183; /* iorvnx8hi3 */

        case E_VNx4HImode:
          if (pattern589 (x3, 
E_VNx4HImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8186; /* iorvnx4hi3 */

        case E_VNx2HImode:
          if (pattern589 (x3, 
E_VNx2HImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8189; /* iorvnx2hi3 */

        case E_VNx4SImode:
          if (pattern589 (x3, 
E_VNx4SImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8192; /* iorvnx4si3 */

        case E_VNx2SImode:
          if (pattern589 (x3, 
E_VNx2SImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8195; /* iorvnx2si3 */

        case E_VNx2DImode:
          if (pattern589 (x3, 
E_VNx2DImode) != 0
              || !
#line 4715 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8198; /* iorvnx2di3 */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x7 = XEXP (x3, 1);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
            case TRUNCATE:
              operands[3] = x7;
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              switch (pattern49 (x3))
                {
                case 0:
                  return 532; /* ior_ashlsi3 */

                case 1:
                  return 547; /* ior_ashldi3 */

                default:
                  break;
                }
              if (!subreg_lowpart_operator (x7, E_SImode)
                  || pattern659 (x3) != 0
                  || !
#line 6261 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < 32
   && UINTVAL (operands[3]) + UINTVAL (operands[4]) == 32
   && INTVAL (operands[3]) == INTVAL (operands[5])))
                return -1;
              return 796; /* *extrsi5_insn_di */

            case LSHIFTRT:
              switch (pattern304 (x3))
                {
                case 0:
                  if (!
#line 6201 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (SImode) &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == GET_MODE_BITSIZE (SImode))))
                    return -1;
                  return 778; /* *extrsi5_insn */

                case 1:
                  if (!
#line 6201 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (DImode) &&
   (UINTVAL (operands[3]) + UINTVAL (operands[4]) == GET_MODE_BITSIZE (DImode))))
                    return -1;
                  return 781; /* *extrdi5_insn */

                default:
                  return -1;
                }

            case AND:
              x11 = XEXP (x4, 1);
              operands[2] = x11;
              x8 = XEXP (x7, 0);
              operands[3] = x8;
              x12 = XEXP (x7, 1);
              operands[4] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern942 (x3, 
E_SImode) != 0
                      || !aarch64_simd_shift_imm_si (operands[2], E_SImode)
                      || GET_MODE (x7) != E_SImode
                      || !register_operand (operands[3], E_SImode)
                      || !const_int_operand (operands[4], E_SImode)
                      || !
#line 6540 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (SImode, UINTVAL (operands[4]),
				      UINTVAL (operands[2]),
				      HOST_WIDE_INT_M1U << UINTVAL (operands[2]) )))
                    return -1;
                  return 856; /* *aarch64_bfisi4_noand_alt */

                case E_DImode:
                  if (pattern942 (x3, 
E_DImode) != 0
                      || !aarch64_simd_shift_imm_di (operands[2], E_DImode)
                      || GET_MODE (x7) != E_DImode
                      || !register_operand (operands[3], E_DImode)
                      || !const_int_operand (operands[4], E_DImode)
                      || !
#line 6540 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_masks_and_shift_for_bfi_p (DImode, UINTVAL (operands[4]),
				      UINTVAL (operands[2]),
				      HOST_WIDE_INT_M1U << UINTVAL (operands[2]) )))
                    return -1;
                  return 857; /* *aarch64_bfidi4_noand_alt */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 1L)
            return -1;
          x11 = XEXP (x4, 1);
          if (GET_CODE (x11) != AND
              || GET_MODE (x11) != E_QImode)
            return -1;
          x20 = XEXP (x11, 0);
          if (GET_CODE (x20) != LSHIFTRT
              || GET_MODE (x20) != E_DImode)
            return -1;
          x21 = XEXP (x20, 1);
          if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 56])
            return -1;
          x22 = XEXP (x11, 1);
          if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x23 = XEXP (x20, 0);
          operands[1] = x23;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode)
              || !
#line 8397 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
            return -1;
          return 1227; /* gmi */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern50 (x3))
        {
        case 0:
          return 535; /* ior_ashrsi3 */

        case 1:
          return 550; /* ior_ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern52 (x3))
        {
        case 0:
          return 538; /* ior_lshrsi3 */

        case 1:
          return 553; /* ior_lshrdi3 */

        case 2:
          if (!
#line 6216 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (SImode)
   && (UINTVAL (operands[3]) + UINTVAL (operands[4])
       == GET_MODE_BITSIZE (SImode))))
            return -1;
          return 784; /* *extrsi5_insn_alt */

        case 3:
          if (!
#line 6216 "../../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[3]) < GET_MODE_BITSIZE (DImode)
   && (UINTVAL (operands[3]) + UINTVAL (operands[4])
       == GET_MODE_BITSIZE (DImode))))
            return -1;
          return 787; /* *extrdi5_insn_alt */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern50 (x3))
        {
        case 0:
          return 541; /* ior_rotrsi3 */

        case 1:
          return 556; /* ior_rotrdi3 */

        default:
          return -1;
        }

    case ROTATE:
      switch (pattern50 (x3))
        {
        case 0:
          return 544; /* ior_rotlsi3 */

        case 1:
          return 559; /* ior_rotldi3 */

        default:
          return -1;
        }

    case NOT:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x7 = XEXP (x3, 1);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern721 (x3, 
E_SImode) != 0)
                return -1;
              return 590; /* iornsi3 */

            case E_DImode:
              if (pattern721 (x3, 
E_DImode) != 0)
                return -1;
              return 592; /* iorndi3 */

            case E_V8QImode:
              if (pattern721 (x3, 
E_V8QImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1327; /* iornv8qi3 */

            case E_V16QImode:
              if (pattern721 (x3, 
E_V16QImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1330; /* iornv16qi3 */

            case E_V4HImode:
              if (pattern721 (x3, 
E_V4HImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1331; /* iornv4hi3 */

            case E_V8HImode:
              if (pattern721 (x3, 
E_V8HImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1334; /* iornv8hi3 */

            case E_V2SImode:
              if (pattern721 (x3, 
E_V2SImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1335; /* iornv2si3 */

            case E_V4SImode:
              if (pattern721 (x3, 
E_V4SImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1338; /* iornv4si3 */

            case E_V2DImode:
              if (pattern721 (x3, 
E_V2DImode) != 0
                  || !
#line 328 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1339; /* iornv2di3 */

            default:
              return -1;
            }

        case ASHIFT:
          switch (pattern376 (x3))
            {
            case 0:
              return 604; /* ior_one_cmpl_ashlsi3 */

            case 1:
              return 619; /* ior_one_cmpl_ashldi3 */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern376 (x3))
            {
            case 0:
              return 607; /* ior_one_cmpl_ashrsi3 */

            case 1:
              return 622; /* ior_one_cmpl_ashrdi3 */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern376 (x3))
            {
            case 0:
              return 610; /* ior_one_cmpl_lshrsi3 */

            case 1:
              return 625; /* ior_one_cmpl_lshrdi3 */

            default:
              return -1;
            }

        case ROTATERT:
          switch (pattern376 (x3))
            {
            case 0:
              return 613; /* ior_one_cmpl_rotrsi3 */

            case 1:
              return 628; /* ior_one_cmpl_rotrdi3 */

            default:
              return -1;
            }

        case ROTATE:
          switch (pattern376 (x3))
            {
            case 0:
              return 616; /* ior_one_cmpl_rotlsi3 */

            case 1:
              return 631; /* ior_one_cmpl_rotldi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_517 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern447 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3242; /* ssaddv8qi3 */

        case 1:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3254; /* ssaddv16qi3 */

        case 2:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3258; /* ssaddv4hi3 */

        case 3:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3270; /* ssaddv8hi3 */

        case 4:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3274; /* ssaddv2si3 */

        case 5:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3286; /* ssaddv4si3 */

        case 6:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3290; /* ssaddv2di3 */

        case 7:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3294; /* ssaddhi3 */

        case 8:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3298; /* ssaddqi3 */

        case 9:
          *pnum_clobbers = 2;
          return 3302; /* aarch64_ssaddsi3 */

        case 10:
          *pnum_clobbers = 2;
          return 3304; /* aarch64_ssadddi3 */

        case 11:
          if (!
#line 4457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8098; /* ssaddvnx16qi3 */

        case 12:
          if (!
#line 4457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8100; /* ssaddvnx8hi3 */

        case 13:
          if (!
#line 4457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8102; /* ssaddvnx4si3 */

        case 14:
          if (!
#line 4457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8104; /* ssaddvnx2di3 */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != SIGN_EXTEND)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      x9 = XEXP (x6, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[2] = x9;
          x10 = XEXP (x5, 1);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1150 (x3, 
E_V4SImode, 
E_V4HImode) != 0
                          || !
#line 5737 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3576; /* aarch64_sqdmlalv4hi */

                    case E_V2DImode:
                      if (pattern1150 (x3, 
E_V2DImode, 
E_V2SImode) != 0
                          || !
#line 5737 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3577; /* aarch64_sqdmlalv2si */

                    case E_SImode:
                      if (pattern1150 (x3, 
E_SImode, 
E_HImode) != 0
                          || !
#line 5737 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3578; /* aarch64_sqdmlalhi */

                    case E_DImode:
                      if (pattern1150 (x3, 
E_DImode, 
E_SImode) != 0
                          || !
#line 5737 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3579; /* aarch64_sqdmlalsi */

                    default:
                      return -1;
                    }

                case VEC_SELECT:
                  x12 = XEXP (x11, 1);
                  if (GET_CODE (x12) != PARALLEL
                      || XVECLEN (x12, 0) != 1)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[3] = x13;
                  x14 = XVECEXP (x12, 0, 0);
                  operands[4] = x14;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern1267 (x3, 
E_SImode, 
E_HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[3]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[3], E_V4HImode)
                              || !
#line 5872 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3592; /* aarch64_sqdmlal_lanehi */

                        case E_V8HImode:
                          if (!register_operand (operands[3], E_V8HImode)
                              || !
#line 5919 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3596; /* aarch64_sqdmlal_laneqhi */

                        default:
                          return -1;
                        }

                    case E_DImode:
                      if (pattern1267 (x3, 
E_DImode, 
E_SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[3]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[3], E_V2SImode)
                              || !
#line 5872 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3593; /* aarch64_sqdmlal_lanesi */

                        case E_V4SImode:
                          if (!register_operand (operands[3], E_V4SImode)
                              || !
#line 5919 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3597; /* aarch64_sqdmlal_laneqsi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x11 = XEXP (x10, 0);
              switch (pattern976 (x11))
                {
                case 0:
                  x13 = XEXP (x11, 0);
                  x15 = XEXP (x13, 0);
                  operands[3] = x15;
                  x16 = XEXP (x13, 1);
                  x17 = XVECEXP (x16, 0, 0);
                  operands[4] = x17;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1289 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (pattern1347 (x10))
                        {
                        case 0:
                          if (!
#line 5775 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3584; /* aarch64_sqdmlal_lanev4hi */

                        case 1:
                          if (!
#line 5848 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3590; /* aarch64_sqdmlal_laneqv4hi */

                        default:
                          return -1;
                        }

                    case E_V2DImode:
                      if (pattern1289 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      switch (pattern1348 (x10))
                        {
                        case 0:
                          if (!
#line 5775 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3585; /* aarch64_sqdmlal_lanev2si */

                        case 1:
                          if (!
#line 5848 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3591; /* aarch64_sqdmlal_laneqv2si */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1183 (x3, 
E_V4SImode, 
E_HImode, 
E_SImode, 
E_V4HImode) != 0
                          || !
#line 5982 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3602; /* aarch64_sqdmlal_nv4hi */

                    case E_V2DImode:
                      if (pattern1183 (x3, 
E_V2DImode, 
E_SImode, 
E_DImode, 
E_V2SImode) != 0
                          || !
#line 5982 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3603; /* aarch64_sqdmlal_nv2si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x18 = XEXP (x9, 0);
          operands[2] = x18;
          x10 = XEXP (x5, 1);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != VEC_SELECT)
                return -1;
              x19 = XEXP (x9, 1);
              operands[4] = x19;
              x13 = XEXP (x11, 0);
              operands[3] = x13;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1212 (x3, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0
                      || !
#line 6005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3604; /* aarch64_sqdmlal2v8hi_internal */

                case E_V2DImode:
                  if (pattern1212 (x3, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0
                      || !
#line 6005 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3605; /* aarch64_sqdmlal2v4si_internal */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x11 = XEXP (x10, 0);
              switch (pattern976 (x11))
                {
                case 0:
                  x19 = XEXP (x9, 1);
                  operands[5] = x19;
                  x13 = XEXP (x11, 0);
                  x15 = XEXP (x13, 0);
                  operands[3] = x15;
                  x16 = XEXP (x13, 1);
                  x17 = XVECEXP (x16, 0, 0);
                  operands[4] = x17;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1298 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (pattern1347 (x10))
                        {
                        case 0:
                          if (!
#line 6091 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3610; /* aarch64_sqdmlal2_lanev8hi_internal */

                        case 1:
                          if (!
#line 6143 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3614; /* aarch64_sqdmlal2_laneqv8hi_internal */

                        default:
                          return -1;
                        }

                    case E_V2DImode:
                      if (pattern1298 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      switch (pattern1348 (x10))
                        {
                        case 0:
                          if (!
#line 6091 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3611; /* aarch64_sqdmlal2_lanev4si_internal */

                        case 1:
                          if (!
#line 6143 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3615; /* aarch64_sqdmlal2_laneqv4si_internal */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1:
                  x19 = XEXP (x9, 1);
                  operands[4] = x19;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1213 (x3, 
E_V4SImode, 
E_HImode, 
E_SImode, 
E_V8HImode, 
E_V4HImode) != 0
                          || !
#line 6219 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3618; /* aarch64_sqdmlal2_nv8hi_internal */

                    case E_V2DImode:
                      if (pattern1213 (x3, 
E_V2DImode, 
E_SImode, 
E_DImode, 
E_V4SImode, 
E_V2SImode) != 0
                          || !
#line 6219 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3619; /* aarch64_sqdmlal2_nv4si_internal */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern333 (x3))
        {
        case 0:
          if (!
#line 10381 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11031; /* aarch64_sve_sqincdi_pat */

        case 1:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11065; /* *aarch64_sve_sqincdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11068; /* *aarch64_sve_sqincdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11071; /* *aarch64_sve_sqincdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11074; /* *aarch64_sve_sqincdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern337 (x3))
        {
        case 0:
          if (!
#line 10446 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11037; /* aarch64_sve_sqincvnx2di_pat */

        case 1:
          if (!
#line 10823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11089; /* *aarch64_sve_sqincvnx2di_cntp */

        case 2:
          if (!
#line 10467 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11040; /* aarch64_sve_sqincvnx4si_pat */

        case 3:
          if (!
#line 10862 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11092; /* *aarch64_sve_sqincvnx4si_cntp */

        case 4:
          if (!
#line 10502 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11043; /* *aarch64_sve_sqincvnx8hi_pat */

        case 5:
          if (!
#line 10903 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11095; /* *aarch64_sve_sqincvnx8hi_cntp */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2)
        return -1;
      x20 = XVECEXP (x4, 0, 0);
      operands[2] = x20;
      x8 = XEXP (x3, 1);
      operands[1] = x8;
      switch (XINT (x4, 1))
        {
        case 509:
          switch (pattern509 (x3))
            {
            case 0:
              if (!
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12245; /* aarch64_sve_qadd_sqdmullbvnx8hi */

            case 1:
              if (!
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12248; /* aarch64_sve_qadd_sqdmullbvnx4si */

            case 2:
              if (!
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12251; /* aarch64_sve_qadd_sqdmullbvnx2di */

            case 3:
              if (!
#line 2397 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12254; /* aarch64_sve_qadd_sqdmullb_lane_vnx4si */

            case 4:
              if (!
#line 2397 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12256; /* aarch64_sve_qadd_sqdmullb_lane_vnx2di */

            default:
              return -1;
            }

        case 510:
          x21 = XVECEXP (x4, 0, 1);
          operands[3] = x21;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              if (pattern503 (x3, 
E_VNx8HImode, 
E_VNx16QImode) != 0
                  || !
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12246; /* aarch64_sve_qadd_sqdmullbtvnx8hi */

            case E_VNx4SImode:
              if (pattern503 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0
                  || !
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12249; /* aarch64_sve_qadd_sqdmullbtvnx4si */

            case E_VNx2DImode:
              if (pattern503 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0
                  || !
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12252; /* aarch64_sve_qadd_sqdmullbtvnx2di */

            default:
              return -1;
            }

        case 511:
          switch (pattern509 (x3))
            {
            case 0:
              if (!
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12247; /* aarch64_sve_qadd_sqdmulltvnx8hi */

            case 1:
              if (!
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12250; /* aarch64_sve_qadd_sqdmulltvnx4si */

            case 2:
              if (!
#line 2378 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12253; /* aarch64_sve_qadd_sqdmulltvnx2di */

            case 3:
              if (!
#line 2397 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12255; /* aarch64_sve_qadd_sqdmullt_lane_vnx4si */

            case 4:
              if (!
#line 2397 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12257; /* aarch64_sve_qadd_sqdmullt_lane_vnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern36 (x3))
        {
        case 0:
          if (!
#line 7384 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 1085; /* *aarch64_uminsi3_cssc */

        case 1:
          if (!
#line 7384 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 1089; /* *aarch64_umindi3_cssc */

        case 2:
          if (!
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2081; /* uminv8qi3 */

        case 3:
          if (!
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2087; /* uminv16qi3 */

        case 4:
          if (!
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2097; /* uminv4hi3 */

        case 5:
          if (!
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2103; /* uminv8hi3 */

        case 6:
          if (!
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2113; /* uminv2si3 */

        case 7:
          if (!
#line 1754 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2119; /* uminv4si3 */

        case 8:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11459; /* *uminvnx32qi3 */

        case 9:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11463; /* *uminvnx16hi3 */

        case 10:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11467; /* *uminvnx8si3 */

        case 11:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11471; /* *uminvnx4di3 */

        case 12:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11475; /* *uminvnx64qi3 */

        case 13:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11479; /* *uminvnx32hi3 */

        case 14:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11483; /* *uminvnx16si3 */

        case 15:
          if (!
#line 735 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11487; /* *uminvnx8di3 */

        case 16:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7423; /* *post_ra_uminvnx16qi3 */

        case 17:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7428; /* *post_ra_uminvnx8qi3 */

        case 18:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7433; /* *post_ra_uminvnx4qi3 */

        case 19:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7438; /* *post_ra_uminvnx2qi3 */

        case 20:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7443; /* *post_ra_uminvnx8hi3 */

        case 21:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7448; /* *post_ra_uminvnx4hi3 */

        case 22:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7453; /* *post_ra_uminvnx2hi3 */

        case 23:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7458; /* *post_ra_uminvnx4si3 */

        case 24:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7463; /* *post_ra_uminvnx2si3 */

        case 25:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7468; /* *post_ra_uminvnx2di3 */

        case 26:
          if (!
#line 3975 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 7473; /* *post_ra_uminv2di3 */

        case 27:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11492; /* aarch64_sve_single_uminvnx32qi */

        case 28:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11497; /* aarch64_sve_single_uminvnx16hi */

        case 29:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11502; /* aarch64_sve_single_uminvnx8si */

        case 30:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11507; /* aarch64_sve_single_uminvnx4di */

        case 31:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11512; /* aarch64_sve_single_uminvnx64qi */

        case 32:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11517; /* aarch64_sve_single_uminvnx32hi */

        case 33:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11522; /* aarch64_sve_single_uminvnx16si */

        case 34:
          if (!
#line 745 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11527; /* aarch64_sve_single_uminvnx8di */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern318 (x3))
        {
        case 0:
          if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11577; /* aarch64_sve_uclampvnx16qi */

        case 1:
          if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11579; /* aarch64_sve_uclampvnx8hi */

        case 2:
          if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11581; /* aarch64_sve_uclampvnx4si */

        case 3:
          if (!
#line 786 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
            return -1;
          return 11583; /* aarch64_sve_uclampvnx2di */

        case 4:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11593; /* aarch64_sve_uclamp_singlevnx32qi */

        case 5:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11595; /* aarch64_sve_uclamp_singlevnx16hi */

        case 6:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11597; /* aarch64_sve_uclamp_singlevnx8si */

        case 7:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11599; /* aarch64_sve_uclamp_singlevnx4di */

        case 8:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11601; /* aarch64_sve_uclamp_singlevnx64qi */

        case 9:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11603; /* aarch64_sve_uclamp_singlevnx32hi */

        case 10:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11605; /* aarch64_sve_uclamp_singlevnx16si */

        case 11:
          if (!
#line 829 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11607; /* aarch64_sve_uclamp_singlevnx8di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_542 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern449 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3245; /* usaddv8qi3 */

        case 1:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3255; /* usaddv16qi3 */

        case 2:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3261; /* usaddv4hi3 */

        case 3:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3271; /* usaddv8hi3 */

        case 4:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3277; /* usaddv2si3 */

        case 5:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3287; /* usaddv4si3 */

        case 6:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3291; /* usaddv2di3 */

        case 7:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3295; /* usaddhi3 */

        case 8:
          if (!
#line 5170 "../../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3299; /* usaddqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3306; /* usaddsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3308; /* usadddi3 */

        case 11:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8106; /* usaddvnx16qi3 */

        case 12:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8108; /* usaddvnx8hi3 */

        case 13:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8110; /* usaddvnx4si3 */

        case 14:
          if (!
#line 4473 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8112; /* usaddvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern333 (x3))
        {
        case 0:
          if (!
#line 10381 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11032; /* aarch64_sve_uqincdi_pat */

        case 1:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11066; /* *aarch64_sve_uqincdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11069; /* *aarch64_sve_uqincdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11072; /* *aarch64_sve_uqincdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11075; /* *aarch64_sve_uqincdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern337 (x3))
        {
        case 0:
          if (!
#line 10446 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11038; /* aarch64_sve_uqincvnx2di_pat */

        case 1:
          if (!
#line 10823 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11090; /* *aarch64_sve_uqincvnx2di_cntp */

        case 2:
          if (!
#line 10467 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11041; /* aarch64_sve_uqincvnx4si_pat */

        case 3:
          if (!
#line 10862 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11093; /* *aarch64_sve_uqincvnx4si_cntp */

        case 4:
          if (!
#line 10502 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11044; /* *aarch64_sve_uqincvnx8hi_pat */

        case 5:
          if (!
#line 10903 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11096; /* *aarch64_sve_uqincvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_564 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10178; /* while_ugesivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3454 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10188; /* while_ugedivnx4bi_ptest */
}

 int
recog_572 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10177; /* while_ugtsivnx4bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3453 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10187; /* while_ugtdivnx4bi_ptest */
}

 int
recog_582 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10136; /* while_gtsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10146; /* while_gtdivnx16bi_ptest */
}

 int
recog_592 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10095; /* *while_gesivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10105; /* *while_gedivnx4bi_cc */
}

 int
recog_602 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern689 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9979; /* while_rwsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9989; /* while_rwdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9999; /* while_rwsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10009; /* while_rwdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10019; /* while_rwsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10029; /* while_rwdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10039; /* while_rwsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3455 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10049; /* while_rwdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_606 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XINT (x4, 1))
    {
    case 126:
      return recog_600 (x1, insn, pnum_clobbers);

    case 140:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9971; /* while_lesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9981; /* while_ledivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9991; /* while_lesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10001; /* while_ledivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10011; /* while_lesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10021; /* while_ledivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10031; /* while_lesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10041; /* while_ledivnx2bi */

        default:
          return -1;
        }

    case 141:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9972; /* while_ultsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9982; /* while_ultdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9992; /* while_ultsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10002; /* while_ultdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10012; /* while_ultsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10022; /* while_ultdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10032; /* while_ultsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10042; /* while_ultdivnx2bi */

        default:
          return -1;
        }

    case 142:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9973; /* while_ulesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9983; /* while_uledivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9993; /* while_ulesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10003; /* while_uledivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10013; /* while_ulesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10023; /* while_uledivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10033; /* while_ulesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10043; /* while_uledivnx2bi */

        default:
          return -1;
        }

    case 143:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9974; /* while_ltsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9984; /* while_ltdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9994; /* while_ltsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10004; /* while_ltdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10014; /* while_ltsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10024; /* while_ltdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && 
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10034; /* while_ltsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10044; /* while_ltdivnx2bi */

        default:
          return -1;
        }

    case 136:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9975; /* while_gesivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9985; /* while_gedivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9995; /* while_gesivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10005; /* while_gedivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10015; /* while_gesivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10025; /* while_gedivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10035; /* while_gesivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3451 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10045; /* while_gedivnx2bi */

        default:
          return -1;
        }

    case 137:
      switch (pattern689 (x1))
        {
        case 0:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9976; /* while_gtsivnx16bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 9986; /* while_gtdivnx16bi */

        case 1:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 9996; /* while_gtsivnx8bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10006; /* while_gtdivnx8bi */

        case 2:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10016; /* while_gtsivnx4bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10026; /* while_gtdivnx4bi */

        case 3:
          if (aarch64_reg_or_zero (operands[1], E_SImode)
              && aarch64_reg_or_zero (operands[2], E_SImode)
              && (
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return 10036; /* while_gtsivnx2bi */
          if (!aarch64_reg_or_zero (operands[1], E_DImode)
              || !aarch64_reg_or_zero (operands[2], E_DImode)
              || !(
#line 8414 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3452 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
            return -1;
          return 10046; /* while_gtdivnx2bi */

        default:
          return -1;
        }

    case 138:
      return recog_604 (x1, insn, pnum_clobbers);

    case 139:
      return recog_603 (x1, insn, pnum_clobbers);

    case 144:
      return recog_602 (x1, insn, pnum_clobbers);

    case 145:
      return recog_601 (x1, insn, pnum_clobbers);

    case 305:
      switch (pattern691 (x1))
        {
        case 0:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 8))
            return -1;
          return 11005; /* aarch64_sve_pfirstvnx16bi */

        case 1:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
            return -1;
          return 11007; /* aarch64_sve_pfirstvnx8bi */

        case 2:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
            return -1;
          return 11009; /* aarch64_sve_pfirstvnx4bi */

        case 3:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
            return -1;
          return 11011; /* aarch64_sve_pfirstvnx2bi */

        default:
          return -1;
        }

    case 306:
      switch (pattern691 (x1))
        {
        case 0:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 8))
            return -1;
          return 11006; /* aarch64_sve_pnextvnx16bi */

        case 1:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return -1;
          return 11008; /* aarch64_sve_pnextvnx8bi */

        case 2:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return -1;
          return 11010; /* aarch64_sve_pnextvnx4bi */

        case 3:
          if (!
#line 10271 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return -1;
          return 11012; /* aarch64_sve_pnextvnx2bi */

        default:
          return -1;
        }

    case 471:
      switch (pattern693 (x1, 
471))
        {
        case 0:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11222; /* aarch64_ld1vnx32qi_strided2 */

        case 1:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11224; /* aarch64_ld1vnx16hi_strided2 */

        case 2:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11226; /* aarch64_ld1vnx8si_strided2 */

        case 3:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11228; /* aarch64_ld1vnx4di_strided2 */

        case 4:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11230; /* aarch64_ld1vnx16bf_strided2 */

        case 5:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11232; /* aarch64_ld1vnx16hf_strided2 */

        case 6:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11234; /* aarch64_ld1vnx8sf_strided2 */

        case 7:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11236; /* aarch64_ld1vnx4df_strided2 */

        default:
          return -1;
        }

    case 472:
      switch (pattern693 (x1, 
472))
        {
        case 0:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11223; /* aarch64_ldnt1vnx32qi_strided2 */

        case 1:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11225; /* aarch64_ldnt1vnx16hi_strided2 */

        case 2:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11227; /* aarch64_ldnt1vnx8si_strided2 */

        case 3:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11229; /* aarch64_ldnt1vnx4di_strided2 */

        case 4:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11231; /* aarch64_ldnt1vnx16bf_strided2 */

        case 5:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11233; /* aarch64_ldnt1vnx16hf_strided2 */

        case 6:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11235; /* aarch64_ldnt1vnx8sf_strided2 */

        case 7:
          if (!
#line 293 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2
   && aarch64_strided_registers_p (operands, 2, 8)))
            return -1;
          return 11237; /* aarch64_ldnt1vnx4df_strided2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_622 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CALL:
      if (pattern37 (x1) != 0)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      switch (pattern1160 (x3))
        {
        case 0:
          return 63; /* *call_insn */

        case 1:
          if (!
#line 1412 "../../../gcc/config/aarch64/aarch64.md"
(SIBLING_CALL_P (insn)))
            return -1;
          return 65; /* *sibcall_insn */

        default:
          return -1;
        }

    case SET:
      x4 = XEXP (x2, 1);
      switch (GET_CODE (x4))
        {
        case CALL:
          if (pattern357 (x1) != 0)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          res = recog_617 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          x6 = XEXP (x4, 0);
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != UNSPEC
              || pattern985 (x2) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (pattern373 (x3, 
30, 
CLOBBER, 
E_DImode) != 0)
            return -1;
          x8 = XVECEXP (x7, 0, 0);
          operands[0] = x8;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XVECEXP (x9, 0, 0);
          operands[1] = x10;
          if (!const_int_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (GET_MODE (x7) != E_SImode
                  || !(
#line 7868 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1152; /* tlsdesc_small_sve_si */

            case E_DImode:
              if (GET_MODE (x7) != E_DImode
                  || !(
#line 7868 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && TARGET_SVE) && 
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1153; /* tlsdesc_small_sve_di */

            default:
              return -1;
            }

        case PLUS:
          if (!pmode_plus_operator (x4, E_VOIDmode))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != SET)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != SET)
            return -1;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!pmode_register_operand (operands[1], E_VOIDmode))
            return -1;
          x11 = XEXP (x4, 1);
          operands[4] = x11;
          if (!const_int_operand (operands[4], E_VOIDmode))
            return -1;
          x12 = XEXP (x9, 1);
          if (memory_operand (x12, E_VOIDmode))
            {
              res = recog_618 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x13 = XEXP (x9, 0);
          if (GET_CODE (x13) != MEM)
            return -1;
          operands[6] = x13;
          if (aarch64_mem_pair_operator (operands[6], E_TImode))
            {
              res = recog_619 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x14 = XEXP (x3, 0);
          if (GET_CODE (x14) != MEM)
            return -1;
          x15 = XEXP (x14, 0);
          if (!pmode_plus_operator (x15, E_VOIDmode))
            return -1;
          operands[2] = x12;
          x16 = XEXP (x3, 1);
          operands[3] = x16;
          x17 = XEXP (x15, 0);
          if (!rtx_equal_p (x17, operands[0]))
            return -1;
          x18 = XEXP (x13, 0);
          switch (GET_CODE (x18))
            {
            case PLUS:
              operands[8] = x18;
              if (!pmode_plus_operator (operands[8], E_VOIDmode))
                return -1;
              operands[6] = x4;
              operands[7] = x13;
              operands[9] = x14;
              if (aarch64_mem_pair_operator (operands[9], E_SImode)
                  && pattern1356 (x1, 
E_SImode) == 0
                  && 
#line 2235 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (SImode))
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return 100; /* *storewb_pre_pair_4 */
              if (aarch64_mem_pair_operator (operands[9], E_DImode)
                  && pattern1356 (x1, 
E_DImode) == 0
                  && 
#line 2235 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && known_eq (INTVAL (operands[5]),
		INTVAL (operands[4]) + GET_MODE_SIZE (DImode))
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return 101; /* *storewb_pre_pair_8 */
              if (!aarch64_mem_pair_operator (operands[9], E_TImode)
                  || !aarch64_mem_pair_operator (operands[7], E_TImode)
                  || !aarch64_ldp_reg_operand (operands[2], E_TImode))
                return -1;
              operands[10] = x15;
              x19 = XEXP (x15, 1);
              operands[5] = x19;
              if (!const_int_operand (operands[5], E_VOIDmode)
                  || !aarch64_ldp_reg_operand (operands[3], E_TImode))
                return -1;
              x20 = XEXP (x18, 0);
              if (!rtx_equal_p (x20, operands[0]))
                return -1;
              x21 = XEXP (x18, 1);
              if (!rtx_equal_p (x21, operands[4])
                  || !
#line 2265 "../../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && aarch64_mem_pair_offset (operands[4], TImode)
   && known_eq (INTVAL (operands[5]), INTVAL (operands[4]) + 16)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                return -1;
              return 102; /* *storewb_pre_pair_16 */

            case REG:
            case SUBREG:
              if (!rtx_equal_p (x18, operands[1]))
                return -1;
              x19 = XEXP (x15, 1);
              if (GET_CODE (x19) != CONST_INT)
                return -1;
              operands[5] = x4;
              operands[6] = x13;
              if (!aarch64_stp_reg_operand (operands[2], E_VOIDmode))
                return -1;
              operands[7] = x14;
              operands[8] = x15;
              if (!aarch64_stp_reg_operand (operands[3], E_VOIDmode))
                return -1;
              switch (XWINT (x19, 0))
                {
                case 4L:
                  if (!aarch64_mem_pair_operator (operands[6], E_SImode)
                      || !aarch64_mem_pair_operator (operands[7], E_SImode)
                      || !
#line 2289 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], SImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                    return -1;
                  return 103; /* *storewb_post_pair_4 */

                case 8L:
                  if (!aarch64_mem_pair_operator (operands[6], E_DImode)
                      || !aarch64_mem_pair_operator (operands[7], E_DImode)
                      || !
#line 2289 "../../../gcc/config/aarch64/aarch64.md"
(aarch64_mem_pair_offset (operands[4], DImode)
   && !reg_overlap_mentioned_p (operands[0], operands[2])
   && !reg_overlap_mentioned_p (operands[0], operands[3])))
                    return -1;
                  return 104; /* *storewb_post_pair_8 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x4, 0) != 2
              || XINT (x4, 1) != 109
              || GET_MODE (x4) != E_CCmode)
            return -1;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 66
              || GET_MODE (x5) != E_CCmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x9) != CLOBBER)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          x22 = XVECEXP (x4, 0, 0);
          operands[0] = x22;
          x23 = XVECEXP (x4, 0, 1);
          operands[1] = x23;
          x13 = XEXP (x9, 0);
          operands[2] = x13;
          x14 = XEXP (x3, 0);
          operands[3] = x14;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern1257 (
E_SImode) != 0
                  || !
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode))
                return -1;
              return 1173; /* stack_protect_test_si */

            case E_DImode:
              if (pattern1257 (
E_DImode) != 0
                  || !
#line 168 "../../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode))
                return -1;
              return 1174; /* stack_protect_test_di */

            default:
              return -1;
            }

        case SS_PLUS:
          switch (pattern359 (x1))
            {
            case 0:
              return 3302; /* aarch64_ssaddsi3 */

            case 1:
              return 3304; /* aarch64_ssadddi3 */

            default:
              return -1;
            }

        case SS_MINUS:
          switch (pattern359 (x1))
            {
            case 0:
              return 3303; /* aarch64_sssubsi3 */

            case 1:
              return 3305; /* aarch64_sssubdi3 */

            default:
              return -1;
            }

        case UNSPEC_VOLATILE:
          if (pnum_clobbers == NULL
              || pattern364 (x4, 
E_CCmode, 
27) != 0
              || pattern715 (x1, 
SET, 
E_CCmode) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != SET)
            return -1;
          x16 = XEXP (x3, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 5
              || XINT (x16, 1) != 27)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x13 = XEXP (x9, 0);
          operands[0] = x13;
          x24 = XVECEXP (x16, 0, 0);
          operands[2] = x24;
          x25 = XVECEXP (x16, 0, 1);
          operands[3] = x25;
          x26 = XVECEXP (x16, 0, 2);
          operands[4] = x26;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          x27 = XVECEXP (x16, 0, 3);
          operands[5] = x27;
          if (!const_int_operand (operands[5], E_SImode))
            return -1;
          x28 = XVECEXP (x16, 0, 4);
          operands[6] = x28;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          switch (pattern570 (x1))
            {
            case 0:
              *pnum_clobbers = 1;
              return 5365; /* aarch64_compare_and_swapqi */

            case 1:
              *pnum_clobbers = 1;
              return 5366; /* aarch64_compare_and_swaphi */

            case 2:
              *pnum_clobbers = 1;
              return 5367; /* aarch64_compare_and_swapsi */

            case 3:
              *pnum_clobbers = 1;
              return 5368; /* aarch64_compare_and_swapdi */

            case 4:
              *pnum_clobbers = 1;
              return 5369; /* aarch64_compare_and_swapti */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x4, 0) != 1L
              || pattern456 (x1, 
91, 
USE, 
90, 
E_DImode, 
89) != 0)
            return -1;
          return 12995; /* aarch64_smstart_za */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8QImode:
      switch (pattern579 (x3, 
E_VNx8QImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1068 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1074 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1080 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1086 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1092 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1098 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx4QImode:
      switch (pattern579 (x3, 
E_VNx4QImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1069 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1075 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1081 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1087 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1093 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1099 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2QImode:
      switch (pattern579 (x3, 
E_VNx2QImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1070 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1076 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1082 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1088 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1094 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1100 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx4HImode:
      switch (pattern579 (x3, 
E_VNx4HImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1071 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1077 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1083 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1089 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1095 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1101 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2HImode:
      switch (pattern579 (x3, 
E_VNx2HImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1072 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1078 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1084 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1090 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1096 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1102 (insn, operands);

        default:
          return NULL;
        }

    case E_VNx2SImode:
      switch (pattern579 (x3, 
E_VNx2SImode))
        {
        case 0:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1073 (insn, operands);

        case 1:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1079 (insn, operands);

        case 2:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1085 (insn, operands);

        case 3:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1091 (insn, operands);

        case 4:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1097 (insn, operands);

        case 5:
          if (!(
#line 3457 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0) && 
#line 3459 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_1103 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_8 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern870 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1134 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1167 (insn, operands);

    case E_VNx4SFmode:
      if (pattern870 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1145 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1178 (insn, operands);

    case E_VNx2DFmode:
      if (pattern870 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1156 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1189 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern870 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1133 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1166 (insn, operands);

    case E_VNx4SFmode:
      if (pattern870 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1144 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1177 (insn, operands);

    case E_VNx2DFmode:
      if (pattern870 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1155 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1188 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2944 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2952 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1294 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2960 (insn, operands);
}

 rtx_insn *
split_17 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1242 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1249 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2943 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1269 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1274 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2951 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1294 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1308 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2959 (insn, operands);
}

 rtx_insn *
split_22 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2825 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2870 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2910 (insn, operands);
}

 rtx_insn *
split_27 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2812 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2859 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2899 (insn, operands);
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2846 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2887 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2927 (insn, operands);
}

 rtx_insn *
split_37 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2833 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2876 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2916 (insn, operands);
}

 rtx_insn *
split_42 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2819 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2865 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2905 (insn, operands);
}

 rtx_insn *
split_47 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2806 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2854 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2894 (insn, operands);
}

 rtx_insn *
split_52 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1040 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1045 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2840 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1065 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1070 "../../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2882 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1090 "../../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1100 "../../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2922 (insn, operands);
}

 rtx_insn *
split_58 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1106 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1678 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1751 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1803 (insn, operands);

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1691 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1764 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1816 (insn, operands);

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1704 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1777 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1829 (insn, operands);

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1717 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1790 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1842 (insn, operands);

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1726 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1903 (insn, operands);

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1733 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1910 (insn, operands);

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1740 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1917 (insn, operands);

        default:
          return NULL;
        }

    case 1L:
      switch (pattern1104 (x2))
        {
        case 0:
          if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1855 (insn, operands);

        case 1:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1868 (insn, operands);

        case 2:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1881 (insn, operands);

        case 3:
          if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1894 (insn, operands);

        case 4:
          if (pattern1259 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1924 (insn, operands);

        case 5:
          if (pattern1259 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1931 (insn, operands);

        case 6:
          if (pattern1259 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1938 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_65 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1050 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1674 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1747 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1799 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1687 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1760 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1812 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1700 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1773 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1825 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1713 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1786 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1838 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1722 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1899 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1729 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1736 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1851 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1864 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1877 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1890 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1934 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_72 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[4] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern710 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1252 (insn, operands);

        case E_VNx8QImode:
          if (pattern710 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1269 (insn, operands);

        case E_VNx4QImode:
          if (pattern710 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1286 (insn, operands);

        case E_VNx2QImode:
          if (pattern710 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1303 (insn, operands);

        case E_VNx8HImode:
          if (pattern710 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1320 (insn, operands);

        case E_VNx4HImode:
          if (pattern710 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1337 (insn, operands);

        case E_VNx2HImode:
          if (pattern710 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1354 (insn, operands);

        case E_VNx4SImode:
          if (pattern710 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1371 (insn, operands);

        case E_VNx2SImode:
          if (pattern710 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1388 (insn, operands);

        case E_VNx2DImode:
          if (pattern710 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1405 (insn, operands);

        default:
          return NULL;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1052 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1539 (insn, operands);

        case E_VNx8QImode:
          if (pattern1052 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1542 (insn, operands);

        case E_VNx4QImode:
          if (pattern1052 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1545 (insn, operands);

        case E_VNx2QImode:
          if (pattern1052 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1548 (insn, operands);

        case E_VNx8HImode:
          if (pattern1052 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1551 (insn, operands);

        case E_VNx4HImode:
          if (pattern1052 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1554 (insn, operands);

        case E_VNx2HImode:
          if (pattern1052 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1557 (insn, operands);

        case E_VNx4SImode:
          if (pattern1052 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1560 (insn, operands);

        case E_VNx2SImode:
          if (pattern1052 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1563 (insn, operands);

        case E_VNx2DImode:
          if (pattern1052 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1566 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_74 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 299:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case UNSPEC:
          return split_69 (x1, insn);

        case PLUS:
          return split_73 (x1, insn);

        case MINUS:
          return split_70 (x1, insn);

        case MULT:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1247 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1264 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1281 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1298 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1315 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1332 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1349 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1366 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1383 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1400 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1248 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1265 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1282 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1299 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1316 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1333 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1350 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1367 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1384 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1401 (insn, operands);

            default:
              return NULL;
            }

        case UMAX:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1249 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1266 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1283 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1300 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1317 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1334 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1351 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1368 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1385 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1402 (insn, operands);

            default:
              return NULL;
            }

        case SMIN:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1250 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1267 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1284 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1301 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1318 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1335 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1352 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1369 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1386 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1403 (insn, operands);

            default:
              return NULL;
            }

        case UMIN:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1251 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1268 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1285 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1302 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1319 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1336 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1353 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1370 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1387 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1404 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          return split_72 (x1, insn);

        case ASHIFTRT:
          switch (pattern713 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1253 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1270 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1287 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1304 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1321 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1338 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1355 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1372 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1389 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1406 (insn, operands);

            case 10:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1540 (insn, operands);

            case 11:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1543 (insn, operands);

            case 12:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1546 (insn, operands);

            case 13:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1549 (insn, operands);

            case 14:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1552 (insn, operands);

            case 15:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1555 (insn, operands);

            case 16:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1558 (insn, operands);

            case 17:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1561 (insn, operands);

            case 18:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1564 (insn, operands);

            case 19:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1567 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern713 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1254 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1271 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1288 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1305 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1322 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1339 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1356 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1373 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1390 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1407 (insn, operands);

            case 10:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1541 (insn, operands);

            case 11:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1544 (insn, operands);

            case 12:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1547 (insn, operands);

            case 13:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1550 (insn, operands);

            case 14:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1553 (insn, operands);

            case 15:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1556 (insn, operands);

            case 16:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1559 (insn, operands);

            case 17:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1562 (insn, operands);

            case 18:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1565 (insn, operands);

            case 19:
              if (!(
#line 4954 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4960 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1568 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          return split_71 (x1, insn);

        case IOR:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1256 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1273 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1290 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1307 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1324 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1341 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1358 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1375 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1392 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1409 (insn, operands);

            default:
              return NULL;
            }

        case XOR:
          switch (pattern711 (x3))
            {
            case 0:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1257 (insn, operands);

            case 1:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1274 (insn, operands);

            case 2:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1291 (insn, operands);

            case 3:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1308 (insn, operands);

            case 4:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1325 (insn, operands);

            case 5:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1342 (insn, operands);

            case 6:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1359 (insn, operands);

            case 7:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1376 (insn, operands);

            case 8:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1393 (insn, operands);

            case 9:
              if (!(
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1410 (insn, operands);

            default:
              return NULL;
            }

        case SS_PLUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1258 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1275 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1292 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1309 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1326 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1343 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1360 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1377 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1394 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2769 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1411 (insn, operands);

            default:
              return NULL;
            }

        case US_PLUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1259 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1276 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1293 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1310 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1327 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1344 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1361 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1378 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1395 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2770 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1412 (insn, operands);

            default:
              return NULL;
            }

        case SS_MINUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1260 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1277 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1294 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1311 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1328 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1345 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1362 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1379 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1396 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2771 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1413 (insn, operands);

            default:
              return NULL;
            }

        case US_MINUS:
          switch (pattern711 (x3))
            {
            case 0:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1261 (insn, operands);

            case 1:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1278 (insn, operands);

            case 2:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1295 (insn, operands);

            case 3:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1312 (insn, operands);

            case 4:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1329 (insn, operands);

            case 5:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1346 (insn, operands);

            case 6:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1363 (insn, operands);

            case 7:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1380 (insn, operands);

            case 8:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1397 (insn, operands);

            case 9:
              if (!((
#line 4039 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2772 "../../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 4049 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1414 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          switch (pattern714 (x3))
            {
            case 0:
              if (!(
#line 4679 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1485 (insn, operands);

            case 1:
              if (!(
#line 4679 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1487 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          switch (pattern714 (x3))
            {
            case 0:
              if (!(
#line 4679 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1486 (insn, operands);

            case 1:
              if (!(
#line 4679 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4689 "../../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1488 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 351:
      x6 = XVECEXP (x3, 0, 2);
      if (pattern490 (x6, 
393) != 0)
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[4] = x5;
      if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
        return NULL;
      x7 = XVECEXP (x6, 0, 0);
      operands[5] = x7;
      x8 = XVECEXP (x6, 0, 2);
      operands[2] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1228 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !(
#line 6230 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6235 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1977 (insn, operands);

        case E_VNx4SFmode:
          if (pattern1228 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !(
#line 6230 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6235 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1978 (insn, operands);

        case E_VNx2DFmode:
          if (pattern1228 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !(
#line 6230 "../../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6235 "../../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
            return NULL;
          return gen_split_1979 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
